module.exports = {
    isDebug: false,
    logLevel: 'ERROR',
    logRequests: false,
    ignoreDisconnectOnDemo: true, 	    // keep the demo running when client disconnected
    baudrate: 57600,                    // baudrate for serial port
    tempratureCalculationMethod: 1,     // possible values 0...CalculationMethodDefault (sirius/hybrid), 1...CalculationMethodDesign (straton)
    ignoreTemperatureProtection: false, // true to ignore the temperature protection. ATTENTION: only for emergency support
    showAllTemperatures: false, 		// show all temperatures in the front end
    temperatureRequestInterval: 2000,   // interval to collect a temperature from a spot in ms
    maxTemperature: 60,                 // max temperature
    memwatchLogfile: false, 	        // set to false to ignore writing a log file
    memwatchInterval: 5, 				// run every 5 minutes
    memwatchMaxMemory: 130,				// restart if the size exceeds 90MB
    rawTemperatureLogfile: false,       //
    debugTemperatures: false,
    colorFactors: [{ name: 'R', factor: 0.8 }, { name: 'UV', factor: 0.8 }],
    colorReduceTemperatures: [{ name: 'B', temperature: 30, max: 254 }, { name: 'RB', temperature: 30, max: 254 }],
    webserverPort: 80,
    params: {
        params: { ignore: true },
        colorFactors: { ignore: true },
        colorReduceTemperatures: { ignore: true },
        logLevel: { label: 'Loglevel', values: ['DEBUG', 'INFO', 'ERROR'] },
        isDebug: { ignore: true },
        memwatchMaxMemory: { label: 'Memwatch.MaxMemory' },
        memwatchInterval: { label: 'Memwatch.Interval' },
        showAllTemperatures: { label: 'All Temperatures', values: ['true', 'false'] },
    }
}