#!/bin/sh

logger -p notice -t ATI "FW Update: Stop service."
/etc/init.d/ati2 stop;
sleep 1;
/etc/init.d/ati2 stop;
sleep 1;
/etc/init.d/ati2 stop;
sleep 2;
/etc/init.d/ati2 stop;

logger -p notice -t ATI "FW Update: Copy files."
cp -R -f /tmp/data-temp/* /www/ati;
chmod -R 755 /www/ati
cp /tmp/data-temp/openwrt/ati2 /etc/init.d/ati2;
chmod 755 /etc/init.d/ati2

if [ -f "/www/ati/data/temperature.log" ]
then
    rm /www/ati/data/temperature.log;
fi

logger -p notice -t ATI "FW Update: Crontabs."
/etc/init.d/cron stop;
cp /tmp/data-temp/openwrt/crontab.root /etc/crontabs/root;
chmod 755 /etc/crontabs/root;
/etc/init.d/cron start;

logger -p notice -t ATI "FW Update: Merge config."
/www/ati/scripts/merge-settings.sh

logger -p notice -t ATI "FW Update: Set release info 2022.4."
uci set ati.@ati[0].version="2.8.7";
uci set ati.@ati[0].release="2022.4";
uci set ati.@ati[0].show_wizard='0';
uci commit ati;

logger -p notice -t ATI "FW Update: Cleanup temporary files."
rm /tmp/*.tar;
rm -rf /tmp/data-temp;

sleep 2;
logger -p notice -t ATI "FW Update: Start service."
/etc/init.d/ati2 start;

logger -p notice -t ATI "FW Update: Configure NTP Client."
uci -q delete system.ntp.server;
uci add_list system.ntp.server="0.pool.ntp.org";
uci add_list system.ntp.server="1.pool.ntp.org";
uci add_list system.ntp.server="2.pool.ntp.org";
uci add_list system.ntp.server="3.pool.ntp.org";
uci add_list system.ntp.server="time.cloudflare.com";
uci add_list system.ntp.server="time.google.com";
uci commit system;
