#!/bin/sh

led="/sys/class/leds/mediatek:orange:wifi"

if [ "$1" == "-b" ] || [ "$1" == "--blink" ]; then
	echo "LED: blink"
	echo "timer" > $led/trigger
	echo "500" > $led/delay_on
	echo "500" > $led/delay_off
elif [ "$1" == "-f" ] || [ "$1" == "--flash" ]; then
	echo "LED: flash"
	echo "timer" > $led/trigger
	echo "100" > $led/delay_on
	echo "100" > $led/delay_off
elif [ "$1" == "-n" ] || [ "$1" == "--network" ]; then
	echo "LED: network"
	echo "netdev" > $led/trigger
	echo "rx tx" > $led/mode

	board=$(cat /var/sysinfo/model)
	isSTA="$(uci get wireless.sta.disabled)"
	if [ "0" == "$isSTA" ] && [ [ "$board" == "Onion Omega2+" ] || [ "$board" == "Onion Omega2 Pro" ] ]; then
		echo "br-wanwifi" > $led/device_name
	else
		echo "ra0" > $led/device_name
	fi


elif [ "$1" == "--off" ]; then
	echo "LED: off"
	echo none > $led/trigger
	echo 0 > $led/brightness
elif [ "$1" == "--on" ]; then
	echo "LED: on"
	echo none > $led/trigger
	echo 1 > $led/brightness
else
	echo "LED: unknown"
fi