#!/bin/sh

ati_present="$(uci -q show ati)"
if [ "$ati_present" = "" ]
then
	logger -p info -t ATI "Intialize UCI settings.";
	uci import ati < /dev/null;
	uci add ati ati;
	uci set ati.@ati[0].id="$(uci -q get system.@system[0].ati_id)";
	uci set ati.@ati[0].version="$(uci -q get system.@system[0].ati_version)";
	uci set ati.@ati[0].release="$(uci -q get system.@system[0].ati_release)";
	uci set ati.@ati[0].show_wizard="$(uci -q get system.@system[0].ati_show_wizard)";
	uci set ati.@ati[0].initialized="$(uci -q get system.@system[0].ati_initialized)";
	uci set ati.@ati[0].has_adc="$(uci -q get system.@system[0].ati_has_adc)";
	uci set ati.@ati[0].spots_discover="reset";
	uci set ati.@ati[0].spots_count="0";
	
	if [ "$(uci -q get system.@system[0].ati_broadcastinterface)" != "" ]
	then
		uci set ati.@ati[0].broadcastinterface="$(uci -q get system.@system[0].ati_broadcastinterface)"
	fi
	
	uci commit ati

	logger -p info -t ATI "Remove deprecated UCI settings.";
	uci -q delete system.@system[0].ati_id;
	uci -q delete system.@system[0].ati_version;
	uci -q delete system.@system[0].ati_release;
	uci -q delete system.@system[0].ati_show_wizard;
	uci -q delete system.@system[0].ati_initialized;
	uci -q delete system.@system[0].ati_has_adc;
fi