#!/bin/sh

# onion gpio16
# linkit gpio2
board=$(cat /var/sysinfo/model)
if [ "$board" == "Onion Omega2+" ] || [ "$board" == "Onion Omega2 Pro" ]; then
	gpioPin='16'
else
	gpioPin='2'
fi

echo "Reset-service listen on GPIO$gpioPin"
echo $gpioPin > /sys/class/gpio/unexport
echo $gpioPin > /sys/class/gpio/export
echo in > /sys/class/gpio/gpio$gpioPin/direction

a=0
b=0

resetFactory () {
	logger "RESET TO ATI DEFAULTS"

	/etc/init.d/ati2 stop;
	sleep 2;
	/etc/init.d/ati2 stop;
	sleep 2;
	/etc/init.d/ati2 stop;
	sleep 2;
	/etc/init.d/ati2 stop;
	sleep 5;

	pw='root:$1$rZyrEsk.$zfJlgV9J02ixoDq2DEkFY0:19121:0:99999:7:::'
	sed -i "1s/.*/$pw/" /etc/shadow
	rm -rf /www/ati/data/
	cp -R -f /www/ati/openwrt/www/ati/* /www/ati/

	sh /www/ati/scripts/initialize.sh "--force"

	reboot;
}

resetNetwork () {
	echo "RESET NETWORK"
	board=$(cat /var/sysinfo/model)

	if [ "$board" == "Onion Omega2+" ] || [ "$board" == "Onion Omega2 Pro" ]; then
		sh /www/ati/scripts/onion.reset-network.sh
	else
		sh /www/ati/scripts/linkit.reset-network.sh
	fi
}

if [ "$1" != "--force" ]
then
	while [ $a -lt 20 ]
	do
		sleep 1s
		if [ $(cat /sys/class/gpio/gpio$gpioPin/value) -eq 1 ]
		then
			a=$((a+1))
			echo "Reset button pressed: $a s"
			if [ $a == 2 ] ; then
				echo "RESET USER POSSIBLE"
				/www/ati/scripts/led.sh --flash
			elif [ $a == 5 ] ; then
				echo "RESET NETWORK POSSIBLE";
				/www/ati/scripts/led.sh --blink
			elif [ $a -gt 10 ]; then
				echo "FACTORY RESET";
				/www/ati/scripts/led.sh --on
				resetFactory
			fi
		elif [ $a -lt 5 ] && [ $a -gt 1 ]; then
			# button released between 2 and 5 seconds...
			echo "RESET USER!";
			a=0;
			/etc/init.d/ati2 stop;
			sleep 2;
			/etc/init.d/ati2 stop;
			sleep 2;
			/etc/init.d/ati2 stop;
			sleep 2;
			/etc/init.d/ati2 stop;
			cd /www/ati;
			node ./lib/utils/reset-user.js;
			pw='root:$1$rZyrEsk.$zfJlgV9J02ixoDq2DEkFY0:19121:0:99999:7:::'
			sed -i "1s/.*/$pw/" /etc/shadow
			wait;
			/www/ati/scripts/led.sh --network;
			reboot;
		elif [ $a -lt 10 ] && [ $a -gt 4 ]; then
			# button released between 5 and 10 seconds...
			a=0
			resetNetwork
			/www/ati/scripts/led.sh --network
		else
			if [ $a -gt 0 ]; then
				/www/ati/scripts/led.sh --network
			fi
			a=0
		fi
		
		if [ $b -gt 60 ]
		then
			b=0
			c=$(awk '{if (/MemAvailable:/) {print $2;exit}}' /proc/meminfo)
			if [ $c -lt 10000 ]
			then
				touch /etc/hosts;
				echo 'reboot needed!';
				echo $c
				sh /www/ati/scripts/write-debug-info.sh /www/ati/data/oom.log OOM-Exception;
				sleep 2;
				reboot;
			fi
		else
			b=$((b+1))
		fi
	done
else
	/www/ati/scripts/led.sh --on
	resetFactory	
fi
