/*! node-ati 2022-11-25 */
var Memwatch, memwatch, morgan, config = require("./config.js"), debug = config.isDebug, log4js = require("log4js"), logger = (log4js.setGlobalLogLevel(config.logLevel), 
log4js.getLogger("server")), timestamp = isNaN("1669369316992") ? new Date().getTime() : parseInt("1669369316992", 10), softwareVersion = {
    number: "2.8.7",
    date: new Date(timestamp),
    release: "2022.4"
}, Promise = require("promise"), Settings = require("./model/settings.js"), SysFactory = require("./lib/openwrt/system.ts.js").Factory, System = SysFactory.create(), SystemTime = require("./lib/system-time/index.js"), TemperatureLog = require("./lib/temperature-log/index.js"), TemperatureRequest = require("./lib/temperature-request/index.js"), DeviceFactory = require("./lib/devices/device.ts.js").Factory, Dimmer = require("./lib/utils/dimmer.ts.js").Dimmer, appSettings = new Settings(), demoSettings = void 0, hardware = DeviceFactory.create(0), Current = (void 0 === config.memwatchLogfile || config.isDebug || (logger.info("Initialize memwatch"), 
Memwatch = require("./lib/memwatch"), memwatch = new Memwatch(config)), appSettings.load(), 
require("./lib/utils/current.js")), globalCurrent = void 0, sysTime = (!(config.hasADC = !1) !== Current.hasAdcFeature() && !config.isDebug || (config.hasADC = !0, 
globalCurrent = new Current.Current(debug, {
    warningAdcValue: hardware.current.adcWarning,
    maxAdcValue: hardware.current.adcDanger
}), config.isDebug && setInterval(function() {
    var e = Math.floor(625 * Math.random() + 400);
    globalCurrent.setSimulatedAdcValue(e);
}, 2e3)), System.isSystemInitialized() || System.initializeDefaultSettings(!0), 
new SystemTime()), express = require("express"), app = express(), bodyParser = require("body-parser"), methodOverride = require("method-override"), server = require("http").createServer(app), io = require("socket.io").listen(server), _ = require("lodash"), fs = require("fs"), sha1 = require("sha1"), Colors = require("./model/colors.js"), State = require("./model/state.js"), Timelines = require("./model/timelines.js"), lines = new Timelines(), previewLines = new Timelines(), Spots = require("./model/spots.js"), spots = new Spots(), colors = new Colors(), NetworkMember = require("./lib/cluster/index.js"), tempLog = void 0, tempReq = new TemperatureRequest(), MessageHandler = require("./lib/messagehandler/index.js"), dimmer = new Dimmer(sysTime, globalCurrent), FirmwareUpdate = require("./lib/utils/firmware-update.ts.js").FirmwareUpdate, fu = new FirmwareUpdate("straton", ""), networkMember = (fu.startListenForUpdates({
    tarM: "linkit" !== System.version
}), colors.load(), spots.load(), lines.load(), lines.setSpots(spots), lines.setColors(colors), 
sysTime.logStart(), sysTime.setInitialTime(lines.getTimeRange().start, Number(System.getUptime())), 
dimmer.setTimelines(lines), dimmer.setLiveTimelines(lines), dimmer.onFinishDemo = function() {
    demoSettings = void 0;
}, new NetworkMember({
    id: System.getId()
})), updateTimezone = (networkMember.startListen(), networkMember.startPing(), networkMember.on("get-spots", function(e) {
    logger.info("RECV get-spots from a client...");
    var t = spots.getItems();
    e.socket.sendMessage({
        name: System.getHostname(),
        externalId: System.getId(),
        spots: t
    });
}), networkMember.on("get-device-info", function(e) {
    logger.info("RECV get-device-info from a client..."), e.socket.sendMessage({
        name: System.getHostname(),
        externalId: System.getId(),
        swVersion: softwareVersion,
        ip: System.getWifiIP(),
        customName: spots.getLocalCustomName()
    });
}), networkMember.on("logout", function() {
    dimmer.start(), io.emit("logout");
}), networkMember.on("set-preview-timelines", function(e) {
    var t = new Spots(e.request.message.spots), s = new Colors(e.request.message.colors);
    toggleMaster(!1), onSetPreview(e.request.message.timelines, t, s), e.socket.end(JSON.stringify({
        success: !0
    }));
}), networkMember.on("set-time", function(e) {
    sysTime.set(e.request.message.ts, e.request.message.offset), void 0 !== e.request.message.timezone && void 0 !== e.request.message.timezone.name && sysTime.setTimezone(e.request.message.timezone) && System.restartProcess();
}), networkMember.on("set-time-interval", function(e) {
    var t = sysTime.getUtc(), e = e.request.message;
    (t - 5e3 > e.ts || t + 5e3 < e.ts) && (sysTime.set(e.ts, e.offset), logger.info("Set time to " + new Date(e.ts).toISOString())), 
    updateTimezone(e.timezone);
}), networkMember.on("set-timezone", function(e) {
    sysTime.setTimezone(e.request.message.tz) && System.restartProcess();
}), networkMember.on("set-start-up-time", function(e) {
    sysTime.setStartupTime(e.request.message.mode);
}), networkMember.on("set-demo", function(e) {
    demoSettings = e.request.message, dimmer.setDemo(demoSettings);
}), function(e) {
    var t = sysTime.getTimezone();
    void 0 === e || void 0 === e.name || "UTC" !== t && t.name === e.name || sysTime.setTimezone(e) && setTimeout(function() {
        System.restartProcess();
    }, 5e3);
}), toggleMaster = function(e) {
    appSettings.all().isMaster !== e && (appSettings.all().isMaster = e, appSettings.save());
}, saveAllData = (System.isWifiStationEnabled() || (void 0 === appSettings.all().isMaster && (appSettings.all().dataId = Date.now(), 
appSettings.all().isMaster = !0, appSettings.save()), setInterval(function() {
    var e = {
        ts: sysTime.getUtc(),
        offset: sysTime.getOffset(),
        timezone: sysTime.getTimezone()
    };
    logger.debug("Send time info to all clients: ", e), networkMember.sendUdpMessage("set-time-interval", e);
}, 3e5)), setInterval(function() {
    !0 === appSettings.all().isMaster && (logger.debug("Send timelines to all clients... dataId: ", appSettings.all().dataId), 
    sendDataToClients(appSettings.all().dataId));
}, 3e5), function(e, t, s) {
    var e = new Timelines(e), t = new Spots(t), s = new Colors(s), i = spots.getTemperatures();
    return s.save(), t.save(), s.load(), t.load(), e.setSpots(t), e.setColors(s), 
    e.save(), e.load(), e.setSpots(t), e.setColors(s), colors.load(), spots.load(), 
    lines.load(), lines.setColors(colors), lines.setSpots(spots), spots.setTemperatures(i), 
    dimmer.setTimelines(lines), dimmer.setLiveTimelines(lines), r.updateData({
        lines: lines,
        spots: spots,
        colors: colors
    }), networkMember.sendUdpMessage("set-time", {
        ts: new Date().getTime(),
        offset: sysTime.getOffset(),
        timezone: sysTime.getTimezone()
    }), !0;
}), sendDataToClients = function(e) {
    var s, i, t = networkMember.getConnections();
    return logger.debug(t), t && (s = [], i = {
        ts: Date.now(),
        time: new Date().getTime(),
        timezone: sysTime.getTimezone(),
        offset: sysTime.getOffset(),
        dataId: e,
        lines: lines.getRawData(),
        spots: spots.getRawData(),
        colors: colors.getItems()
    }, _.forOwn(t, function(e, t) {
        networkMember.createClient(e.address).then(function(e) {
            s.push(networkMember.sendClientMessage(e, {
                command: "set-timelines",
                message: i
            }).then(function(e) {
                logger.debug(e);
            }).catch(function(e) {
                logger.error(e);
            }));
        });
    })), Promise.all(s);
}, currentState = (networkMember.on("set-timelines", function(e) {
    logger.info("RECV set-timelines from a master..."), updateTimezone(e.request.message.timezone);
    var t = Date.now();
    (e.request.message.ts + 5e3 < t || e.request.message.ts - 5e3 > t) && sysTime.set(e.request.message.time, e.request.message.offset), 
    appSettings.all().dataId === e.request.message.dataId ? logger.info("Already saved new timelines...") : (logger.info("Save new timelines from master..."), 
    pauseTimer(), appSettings.all().isMaster = !1, appSettings.all().dataId = e.request.message.dataId, 
    appSettings.save(), t = saveAllData(e.request.message.lines, e.request.message.spots, e.request.message.colors), 
    e.socket.end(JSON.stringify({
        name: System.getHostname(),
        externalId: System.getId(),
        success: t
    })), continueTimer());
}), new State(spots.getChannelColors())), getChannelValue = function(e, t, s) {
    return void 0 !== t && (2 < e && (e *= t.factor), void 0 !== t.valueTemperature && t.valueTemperature.max < e && t.valueTemperature.temperature > spots.maxLocalTemperature && (e = t.valueTemperature.max), 
    void 0 !== t.power && (e *= t.power), void 0 !== s && (e *= s), 1 !== e || void 0 !== t.previousValue && 0 !== t.previousValue || (e = 2)), 
    0 === e ? 0 : Math.round(3 + e * (252 / 255));
}, isPauseTimer = !1, pauseTimer = function() {
    isPauseTimer = !0;
}, continueTimer = function() {
    isPauseTimer = !1;
}, proxy = (currentState.on("time-preview-start", function() {
    logger.warn("stop timer and start time preview"), dimmer.stop();
}), currentState.on("time-preview-stop", function() {
    logger.warn("stop time preview and start timer");
}), currentState.on("color-preview-start", function() {
    logger.warn("color preview start");
}), currentState.on("color-preview-stop", function() {
    logger.warn("color preview stop");
}), currentState.on("test-preview-start", function() {
    for (var e = new Timelines(), t = new Spots(), s = new Colors(), r = (e.load(), 
    t.load(), s.load(), tempReq.setSpots(t), onSetPreview(e, t, s), dimmer.stop(), 
    e.getItems()), n = 0; n < r.length; n++) {
        var o = r[n], a = o.nodes[2], m = _.cloneDeep(a.color);
        for (m._id = 1e3, m.name = "TEST-COLOR", i = 0; i < m.values.length; i++) m.values[i].value = 0;
        dimmer.setActiveNode(o._id, a.index, 100, m);
    }
    logger.warn("test preview start");
}), currentState.on("test-preview-stop", function() {
    logger.warn("test preview stop");
}), networkMember.on("color-change", function(e) {
    e = e.request.message;
    dimmer.updateColorActiveNode(e.name, e.value);
}), networkMember.on("preview-timestamp", function(e) {
    e = e.request.message;
    dimmer.stop(), dimmer.setTimestamp(e.value, !0);
}), networkMember.on("color-preview", function(e) {
    e = e.request.message;
    currentState.setIsColorPreview(e.enabled), e.enabled && lines.resetPreviousValues();
}), networkMember.on("update-node", function(e) {
    e = e.request.message;
    dimmer.setActiveNode(e.parent, e.index, e.value, e.color);
}), networkMember.on("preview-stop", function() {
    dimmer.start();
}), networkMember.on("disconnect", function() {
    dimmer.start();
}), io.sockets.on("connection", function(e) {
    e.on("color-change", function(e) {
        dimmer.updateColorActiveNode(e.name, e.value), networkMember.sendUdpMessageTwice("color-change", e);
    }), e.on("preview-timestamp", function(e) {
        networkMember.sendUdpMessage("preview-timestamp", e), dimmer.stop(), dimmer.setTimestamp(e.value, !0);
    }), e.on("color-preview", function(e) {
        networkMember.sendUdpMessage("color-preview", e), e.enabled && lines.resetPreviousValues();
    }), e.on("test-preview", function(e) {
        currentState.setIsTestPreview(e.enabled), e.time && sysTime.set(e.time.ts, e.time.offset);
    }), e.on("test-preview-color", function(e) {
        dimmer.stop();
        for (var t = dimmer.getLiveTimelines().getItems(), s = 0; s < t.length; s++) {
            var r = t[s], n = r.nodes[2], o = _.cloneDeep(n.color);
            for (i = 0; i < o.values.length; i++) e.name === o.values[i].name && (o.values[i].value = e.value);
            dimmer.setActiveNode(r._id, n.index, 100, o);
        }
        logger.warn("test preview set color");
    });
    var t = void 0;
    e.on("update-node", function(e) {
        dimmer.setActiveNode(e.parent, e.index, e.value, e.color), networkMember.sendUdpMessage("update-node", e), 
        void 0 !== t && clearTimeout(t), t = setTimeout(function() {
            networkMember.sendUdpMessageTwice("update-node", e);
        }, 2e3);
    }), e.on("preview-stop", function(e) {
        dimmer.start(), networkMember.sendUdpCommand("preview-stop"), logger.info("frontend: preview-stop");
    }), e.on("disconnect", function() {
        currentState.stopPreview(), networkMember.sendUdpCommand("disconnect"), 
        logger.info("frontend: disconnect");
    }), lines.Initialized() || e.emit("initialize-data");
}), new MessageHandler.Proxy()), temperature = new MessageHandler.TemperatureHandler(), anyOtherLamp = (void 0 !== config.tempratureCalculationMethod && temperature.setCalculationMethod(config.tempratureCalculationMethod), 
temperature.on("temperature-update", function(e) {
    isPauseTimer || tempReq.updateData(e);
}), tempReq.on("temperature-debug-log", function(e) {
    io.emit("temperature-debug-log", e);
}), setInterval(function() {
    var e;
    isPauseTimer || (e = _.map(spots.getItems(), function(e) {
        return {
            temperature: e.temperature,
            externalId: e.externalId,
            rawtemperature: e.rawtemperature,
            online: void 0 !== e.online && e.online
        };
    }), io.emit("temperature-spots", e));
}, 2e3), setInterval(function() {
    isPauseTimer || networkMember.sendUdpMessage("temperature", _.map(spots.getOwnItems(), function(e) {
        return {
            temperature: e.temperature,
            rawtemperature: e.rawtemperature,
            externalId: e.externalId
        };
    }));
}, 5e3), networkMember.on("timeline-visible", function(e) {
    var t = lines.findById(e.request.message._id);
    void 0 !== t && (t.visible = e.request.message.visible);
}), networkMember.on("spots-active", function(e) {
    dimmer.setActiveSpots(e.request.message.spots, e.request.message.active);
}), networkMember.on("temperature", function(e) {
    spots.updateExternalTemperature(e.request.message);
}), !1), masterTimeout = (networkMember.on("ping", function(e) {
    spots.updateOnlineState(e), anyOtherLamp = !0;
}), 30), fanSpeedHandler = (setTimeout(function() {
    anyOtherLamp || appSettings.all().isMaster || _.some(spots.getExternalItems()) || (logger.error("Become master because no master is available in network after " + masterTimeout + " seconds!"), 
    appSettings.all().isMaster = !0, appSettings.all().dataId = Date.now(), appSettings.save());
}, 1e3 * masterTimeout), setTimeout(function() {
    System.updateByNtp();
}, 12e4), setTimeout(function() {
    System.updateByNtp();
}, 6e5), setInterval(function() {
    System.updateByNtp();
}, 36e5), networkMember.on("new-device", function(e) {
    !0 === appSettings.all().isMaster && (logger.info("new device " + e), networkMember.sendClientMessageAll({
        command: "get-spots"
    }).then(function(e) {
        _.each(e, function(e) {
            logger.info("receive get-spots " + e.data.name + " (" + e.data.externalId + ")"), 
            spots.addExternalItems(e.data), lines.setSpots(spots);
        }), saveAllData(lines, spots, colors), io.emit("new-spots", {});
    }));
}), new MessageHandler.FanSpeedHandler()), serialPort = (fanSpeedHandler.on("fanspeed", function(t) {
    var e, s;
    10 < t || (e = spots.getItems(), s = !1, _.forEach(e, function(e) {
        void 0 !== e.fanSpeed && (e.fanSpeed = parseInt(t, 10), s = !0);
    }), s && spots.save());
}), proxy.addHandler(11, temperature), proxy.addHandler(89, fanSpeedHandler), require("./lib/communication/serial.ts.js").Factory.create()), initializeDevice = function() {
    lines.setSpots(spots), tempReq.setSpots(spots), (tempLog = new TemperatureLog(spots)).startLogging(), 
    dimmer.onSendPackages = function(e, t) {
        serialPort.addPackages(e);
    }, setTimeout(function() {
        dimmer.start(), setInterval(function() {
            var e = [];
            tempReq.getPackages(e), serialPort.addPackages(e);
        }, 1e3);
    }, 500);
    var e = [];
    tempReq.getInitalPackages(e), serialPort.addPackages(e);
}, discoverDevice = function(e, t) {
    var s = new (require("./lib/utils/discover-spots.ts.js").DiscoverSpots)();
    s.discover(serialPort, t).then(function() {
        hardware = DeviceFactory.create(s.getNumberOfAvailableSpots()), logger.info("Discover " + s.getNumberOfAvailableSpots() + " spots"), 
        spots.enableLocalItems(hardware.numberOfSpots), void 0 !== globalCurrent && (globalCurrent.updateOptions({
            warningAdcValue: hardware.current.adcWarning,
            maxAdcValue: hardware.current.adcDanger
        }), dimmer.setAdcBoundaries(globalCurrent.getWarningAdc(), globalCurrent.getMaxAdc())), 
        initializeDevice(), void 0 !== e && e();
    });
}, onOpenSerialPort = function(e) {
    e ? logger.error("serialport failed to open: " + e) : (logger.info("serialport opened"), 
    (config.hasADC ? discoverDevice : (serialPort.setPackageDelay(6), spots.enableLocalItems(hardware.numberOfSpots), 
    initializeDevice))());
}, initializeSerialport = function() {
    serialPort.initialize({
        baudRate: config.baudrate
    }), serialPort.on("data", function(e) {
        for (var t = [], s = 0; s < e.length; s++) t.push(e[s]);
        proxy.addRawData(t);
    }), serialPort.on("simulated-data", function(e) {
        io.emit("simulated-data", e);
    }), serialPort.open(onOpenSerialPort);
}, cacheTime = (initializeSerialport(), void 0 !== globalCurrent && dimmer.setAdcBoundaries(globalCurrent.getWarningAdc(), globalCurrent.getMaxAdc()), 
864e5), Requests = (app.use(express.static(__dirname + "/public", {
    maxAge: cacheTime
})), app.use(express.bodyParser()), !0 === config.logRequests && (morgan = require("morgan"), 
app.use(morgan("dev"))), app.use(bodyParser.urlencoded({
    extended: "true"
})), app.use(bodyParser.json()), app.use(bodyParser.json({
    type: "application/vnd.api+json"
})), app.use(methodOverride()), app.use(require("express-session")({
    secret: "ati.flex",
    resave: !1,
    saveUninitialized: !1
})), require("./requests.js")), r = new Requests({
    network: networkMember,
    appSettings: appSettings,
    io: io,
    version: softwareVersion,
    lines: lines,
    spots: spots,
    time: sysTime,
    colors: colors,
    state: currentState,
    dimmer: dimmer,
    config: config
}), RequestsConfig = require("./requests.config.js"), rc = new RequestsConfig({
    appSettings: appSettings
});

function requiredAuthentication(e, t, s) {
    r.auth(e, t, s);
}

require("./router.js")(app, r, rc, requiredAuthentication), app.get("/api/current", requiredAuthentication, function(e, t) {
    void 0 !== globalCurrent ? t.json(globalCurrent.getLastResult()) : t.status(500).send("Not found");
}), app.get("/api/read-current", requiredAuthentication, function(e, t) {
    void 0 !== globalCurrent ? globalCurrent.get(function(e) {
        t.json(e);
    }) : t.status(500).send("Not found");
}), app.get("/api/temperatures", requiredAuthentication, function(e, t) {
    tempLog.getStringData(function(e) {
        t.send(e);
    });
}), app.post("/api/delete-spot", requiredAuthentication, function(e, t) {
    spots.removeByExternalId(e.body.externalId), appSettings.all().dataId = Date.now(), 
    appSettings.save(), saveAllData(lines, spots, colors), sendDataToClients(appSettings.all().dataId).then(function() {
        t.json({
            lines: lines.getItems(),
            spots: spots.getItems(),
            colors: colors.getItems()
        });
    });
}), app.put("/api/data", requiredAuthentication, function(e, t) {
    pauseTimer(), appSettings.all().isMaster = !0, appSettings.all().dataId = Date.now(), 
    appSettings.save(), saveAllData(e.body.timelines, e.body.spots, e.body.colors);
    e = [];
    tempReq.getInitalPackages(e), serialPort.addPackages(e), continueTimer(), sendDataToClients(appSettings.all().dataId).then(function() {
        t.json({
            lines: lines.getItems(),
            spots: spots.getItems(),
            colors: colors.getItems()
        });
    });
}), app.get("/ADC/:value", requiredAuthentication, function(e, t) {
    e = parseInt(e.params.value, 10);
    globalCurrent.setSimulatedAdcValue(e), t.json();
}), app.get("/initialize-defaults", requiredAuthentication, function(e, t) {
    System.initializeDefaultSettings(!0), t.json();
}), app.get("/api/status", requiredAuthentication, function(e, t) {
    t.json(currentState);
}), app.get("/api/raw-temperatures", requiredAuthentication, function(e, t) {
    t.json({
        temperatures: tempReq.getRawTemperatures(),
        ts: Date.now()
    });
});

var onSetPreview = function(e, t, s) {
    (previewLines = new Timelines(e)).setSpots(t), previewLines.setColors(s), dimmer.setLiveTimelines(previewLines);
};

app.put("/api/preview", requiredAuthentication, function(e, t) {
    onSetPreview(e.body.timelines, spots, colors), toggleMaster(!0);
    var s, i, r = networkMember.getConnections();
    logger.debug(r), r && (s = [], i = {
        timelines: e.body.timelines,
        spots: spots.getRawData(),
        colors: colors.getItems()
    }, _.forOwn(r, function(e, t) {
        networkMember.createClient(e.address).then(function(e) {
            s.push(networkMember.sendClientMessage(e, {
                command: "set-preview-timelines",
                message: i
            }).then(function(e) {
                logger.debug(e);
            }).catch(function(e) {
                logger.error(e);
            }));
        });
    })), t.json(previewLines.getItems());
}), app.post("/api/time", requiredAuthentication, function(e, t) {
    var s = new Date(e.body.ts), i = new Date();
    logger.error("new timestamp -- old: " + i.toISOString() + "(" + sysTime.getOffset() + "), new: " + s.toISOString() + "(" + e.body.offset + ")"), 
    sysTime.set(e.body.ts, e.body.offset), networkMember.sendUdpMessage("set-time", {
        ts: e.body.ts,
        offset: e.body.offset,
        timezone: sysTime.getTimezone()
    }), t.json({
        ts: sysTime.get()
    });
}), app.post("/api/test", requiredAuthentication, function(r, n) {
    var e = 0, o = (void 0 === serialPort && (appSettings.create(r.body.lamp), initializeSerialport(), 
    e = 1e3), appSettings.all().application.test.step);
    appSettings.all().application.test.delay;
    setTimeout(function() {
        var e = null, t = 1, s = !0, i = 50;
        "T5" === r.body.type && (i = 100, serialPort.write([ r.body.address, 88, 249 ])), 
        e = setInterval(function() {
            getChannelValue(t);
            s && t <= r.body.value[0] ? t += o : (s = !1, t -= o), t <= 0 && (t = 0, 
            "LED" === r.body.type && serialPort.write([ r.body.address, 11, 11 ]), 
            n.json({
                success: !0
            }), clearInterval(e)), serialPort.write([ r.body.address, 1, getChannelValue(t) ]), 
            "T5" !== r.body.type && (serialPort.write([ r.body.address, 2, getChannelValue(t) ]), 
            serialPort.write([ r.body.address, 3, getChannelValue(t) ]), serialPort.write([ r.body.address, 4, getChannelValue(t) ]));
        }, i);
    }, e);
}), app.post("/api/setup", requiredAuthentication, function(i, e) {
    appSettings.all().user.name = i.body.user.name, appSettings.all().user.password = sha1(i.body.user.password), 
    appSettings.all().user.timezone = i.body.timezone, appSettings.showWizard(!1), 
    appSettings.all().initialized = !0, spots.setLocalCustomName(i.body.hostname), 
    discoverDevice(function() {
        spots.save(), lines.setSpots(spots, !0), "single" === i.body.sections ? (lines.groupToOneTimeline(), 
        lines.save(), lines.load(), lines.setSpots(spots, !0), lines.setColors(colors)) : lines.save(), 
        require("./lib/openwrt/user.js").setPW("root", i.body.user.password, function(e, t) {
            System.setHostname(i.body.hostname);
            var s = i.body.wifi;
            "sta" === s.mode ? (System.setWifiStation(s.clientSsid.SSID, s.password), 
            appSettings.all().isMaster = !1) : "ap" === s.mode && (System.setWifiAp(s.ssid, s.password), 
            appSettings.all().isMaster = !0), sysTime.setTimezone(i.body.timezone), 
            setTimeout(function() {
                appSettings.save(), System.commitWifiSettings(), System.reboot();
            }, 2e3);
        });
    }, !0), e.json({
        success: !0
    });
}), app.get("/api/par-table", requiredAuthentication, function(e, t) {
    t.json(hardware.parTable);
}), app.get("/api/test-discover", requiredAuthentication, function(e, t) {
    !0 !== appSettings.all().initialized && sha1("admin") === appSettings.all().user.password ? discoverDevice(function() {
        t.json(hardware);
    }, !0) : t.json({});
}), app.get("/api/demo", requiredAuthentication, function(e, t) {
    demoSettings ? (demoSettings.current = sysTime.getTime(), t.json(demoSettings)) : t.json(null);
}), app.post("/api/demo", requiredAuthentication, function(e, t) {
    void 0 === (demoSettings = e.body).active && (demoSettings.active = !0), void 0 === demoSettings.start && (demoSettings.start = sysTime.getTime(), 
    demoSettings.stop = demoSettings.start + 60 * demoSettings.duration, 86400 < demoSettings.stop && (demoSettings.stop -= 86400)), 
    demoSettings.current = sysTime.getTime(), networkMember.sendUdpMessage("set-demo", demoSettings), 
    dimmer.setDemo(demoSettings), t.json(demoSettings);
}), server.listen(config.webserverPort), logger.info("App listening on port " + config.webserverPort);