/*! node-ati 2022-11-25 */
var _=require("lodash"),dgram=require("dgram"),net=require("net"),EventEmitter=require("events").EventEmitter,util=require("util"),Promise=require("promise"),JsonSocket=require("json-socket"),log4js=require("log4js"),_log=log4js.getLogger("net"),System=require("../openwrt/system.ts.js"),sys=System.Factory.create(),UDPPORT=33333,TCPPORT=33334,_options={multicastInterface:void 0,id:Date.now()};function ClusterMember(e){_options=_.merge({},_options,e);var o=this;o._refreshBroadCastAdress(),o._connections={},o._clientSocketsServer={},o._cachedPingMessage=void 0,o._tcpServer=net.createServer(function(e){o._onTcpClientConnected(e)}),o._tcpServer.listen(TCPPORT,function(){_log.info("TCP JSON server listening on %j",o._tcpServer.address())}),setInterval(function(){o._refreshBroadCastAdress()},3e4),o.on("ping",function(e){var t;_options.id!==e.request.id&&(0!==e.remote.address.indexOf(this._addressMask)?_log.info("ignore ping from: "+e.remote.address):(_log.info("Received ping: "+e.remote.address+" ID: "+e.request.id),t=!1,void 0===o._connections[e.request.id]&&(o._connections[e.request.id]={},t=!0),o._connections[e.request.id].lastTs=Date.now(),o._connections[e.request.id].address=e.remote.address,o._connections[e.request.id].id=e.request.id,t&&o.emit("new-device",o._connections[e.request.id])))})}util.inherits(ClusterMember,EventEmitter);var parseData=function(t){t=t.toString();var o={};try{o=JSON.parse(t)}catch(e){o=void 0,_log.error("UNKNOWN MESSAGE: "+t)}return o};ClusterMember.prototype._refreshBroadCastAdress=function(){var e=sys.getWifiIP();this._hostAddress!==e&&(this._hostAddress=e,this._bcastAddress=this._hostAddress.replace(/((\d{1,3}\.){3})(\d{1,3})/,"$1255"),this._addressMask=this._hostAddress.replace(/((\d{1,3}\.){3})(\d{1,3})/,"$1"))},ClusterMember.prototype._onTcpClientConnected=function(t){var o=this;(t=new JsonSocket(t))._socket.setTimeout(5e3),t._socket.on("timeout",function(){_log.warn("timeout connection "+t._socket.remoteAddress),t._socket.destroy()}),t.on("message",function(e){void 0!==e&&void 0!==e.command&&o.emit(e.command,{request:e,socket:t}),t.end()}),t.on("close",function(){_log.warn("connection closed"),t._socket.destroy()}),t.on("error",function(e){_log.error("Connection: %s",e.message),t._socket.destroy()})},ClusterMember.prototype.hasConnections=function(){return 0<this._connections.length},ClusterMember.prototype.getConnections=function(){return this._connections},ClusterMember.prototype.sendUdpMessage=function(o,e){void 0===this._udpSocket?_log.warn("No udp socket..."+o):(e=new Buffer(JSON.stringify({command:o,message:e,id:_options.id})),this._udpSocket.send(e,0,e.length,UDPPORT,this._bcastAddress,function(e,t){e&&_log.error('Error while sending UDP broadcast command "'+o+'" ('+this._bcastAddress+")",e)}))},ClusterMember.prototype.sendUdpMessageTwice=function(o,e){void 0===this._udpSocket?_log.warn("No udp socket..."+o):(e=new Buffer(JSON.stringify({command:o,message:e,id:_options.id})),this._udpSocket.send(e,0,e.length,UDPPORT,this._bcastAddress,function(e,t){e&&_log.error('Error while sending UDP broadcast command "'+o+'" ('+this._bcastAddress+")",e)}),this._udpSocket.send(e,0,e.length,UDPPORT,this._bcastAddress,function(e,t){e&&_log.error('Error while sending UDP broadcast command "'+o+'" ('+this._bcastAddress+")",e)}))},ClusterMember.prototype.sendUdpCommand=function(e){void 0===this._udpSocket?_log.warn("No udp socket..."+e):(e=new Buffer(JSON.stringify({command:e,id:_options.id})),this._udpSocket.send(e,0,e.length,UDPPORT,this._bcastAddress,function(e,t){e&&_log.error(e)}))},ClusterMember.prototype.startListen=function(){var n=this;n._udpSocket=dgram.createSocket("udp4"),n._udpSocket.on("listening",function(){var e=n._udpSocket.address();_log.info("UDP Server listening on "+e.address+":"+e.port),n._udpSocket.setBroadcast(!0)}),n._udpSocket.on("message",function(e,t){n._onServerMessage(e,t)}),n._udpSocket.bind(UDPPORT),setInterval(function(){var o=Date.now()-3e5;n._connections=_.pickBy(n._connections,function(e,t){return e.lastTs>=o})},6e4)},ClusterMember.prototype.sendPing=function(){void 0===this._cachedPingMessage&&(this._cachedPingMessage=new Buffer(JSON.stringify({command:"ping",id:_options.id})));var e=this._cachedPingMessage,o=this;o._udpSocket.send(e,0,e.length,UDPPORT,o._bcastAddress,function(e,t){e&&_log.error(e),_log.info("Ping to "+o._bcastAddress)})},ClusterMember.prototype.startPing=function(){var e=this,t=setInterval(function(){e.sendPing()},1e3);setTimeout(function(){clearInterval(t),t=setInterval(function(){e.sendPing()},6e3)},7e3),e.sendPing()},ClusterMember.prototype._onServerMessage=function(e,t){var o=parseData(e);void 0!==o&&void 0!==o.command&&o.id!==_options.id?this.emit(o.command,{request:o,remote:t}):void 0===o&&_log.error("error:",e)},ClusterMember.prototype.createClient=function(n){return new Promise(function(e,t){var o=new JsonSocket(new net.Socket);_log.info("Create client for "+n+":"+TCPPORT),o.connect(TCPPORT,n,function(){_log.info("Client connected to: "+n+":"+TCPPORT),e(o)}),o.on("close",function(){_log.info("Client closed")}),o.on("error",function(e){console.log(e),_log.error("Unknown error at TCP client for "+n+":"+TCPPORT,e),void 0!==o&&void 0!==o._socket&&o._socket.destroy()})})},ClusterMember.prototype.sendClientMessageAll=function(e){var t=this.getConnections();if(t){for(var o=[],n=_.keys(t),s=0;s<n.length;s++){var r=t[n[s]].address;_log.info("send to: "+r),o.push(function(s){return new Promise(function(t,o){var n=new JsonSocket(new net.Socket);_log.info("Create client for "+s+":"+TCPPORT),n.connect(TCPPORT,s,function(){_log.info("Client connected to: "+s+":"+TCPPORT),n._socket.setTimeout(5e3),n._socket.on("timeout",function(){_log.warn("timeout client connection!"),n._socket.destroy(),o()}),n._socket.once("message",function(e){_log.info("End receive json data from Server... ("+e.externalId+")"),t({data:e,client:n}),n._socket.end()});try{n.sendMessage(e)}catch(e){_log.error("error while sending data to "+n._socket.remoteAddress,e),void 0!==n&&n._socket.destroy(),o()}}),n.on("close",function(){_log.info("Client closed"),t({})}),n.on("error",function(e){_log.error("Unknown error at TCP client for "+s+":"+TCPPORT,e),void 0!==n&&void 0!==n._socket&&n._socket.destroy()})})}(r))}return Promise.all(o)}},ClusterMember.prototype.sendClientMessage=function(o,n){return new Promise(function(t,e){o._socket.setTimeout(5e3),o._socket.on("timeout",function(){_log.warn("timeout client connection!"),o._socket.destroy()}),o._socket.once("message",function(e){_log.info("End receive data from Server..."),t({data:e,client:o}),o._socket.end()});try{o.sendMessage(n)}catch(e){_log.error("error while sending data to "+o._socket.remoteAddress,e),void 0!==o&&o._socket.destroy()}})},module.exports=ClusterMember;