/*! node-ati 2022-11-25 */
"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.ExecutionContext=exports.AbstractSystem=void 0;var _=require("lodash"),log4js_1=require("log4js"),AbstractSystem=function(){function t(t){this._id=void 0,this.version=t,this.log=log4js_1.getLogger("System"),this.log.info("create system object for os version: "+this.version)}return t.prototype.initialize=function(t){this.log.trace("initialize options",t),this._initialized=!0},t.prototype.getWifiIP=function(){return this._getWifiIp()},t.prototype.getHostname=function(){var t=new ExecutionContext("uci get system.@system[0].hostname");return this._execute(t)?t.res:""},t.prototype.getDefaultHostname=function(){return"ATI-Straton-"+this.getId()},t.prototype.getId=function(){var t;return void 0===this._id&&(t=new ExecutionContext("uci get ati.@ati[0].id"),this._execute(t)&&""!==t.res||(this.log.warn("Unable to find the ati id in the settings, so try to genrate a new one..."),t.cmd="/www/ati/scripts/get-id.sh",this._execute(t))?this._id=parseInt(t.res,10):(this.log.error("Unable to find the ati id in the system, use fallback 10000!"),this._id=1e4)),this._id},t.prototype.isSystemInitialized=function(){var t=new ExecutionContext("uci get ati.@ati[0].initialized");return this._execute(t)?"1"===t.res:(this.log.error("ati_initialized not set in ati.@ati[0]!"),!1)},t.prototype.initializeDefaultSettings=function(t){this._executeCommand("/www/ati/scripts/initialize.sh --force")&&this.reboot(),this.log.error("Unable to initialize default settings!")},t.prototype.getWifiApConfig=function(){return this._getWifiOptions("ap")},t.prototype.getWifiStationConfig=function(t){var e=this._getWifiOptions("sta");return!0!==t&&(e.key="****"),e},t.prototype.reboot=function(){return!!this._executeCommand("reboot")||(this.log.error("Unable to reboot the device!"),!1)},t.prototype.restartProcess=function(){this._executeCommand("/www/ati/scripts/restart.sh")},t.prototype.setHostname=function(t){var e=new ExecutionContext("set-hostname"),i=(e.param=[t],this);return this._executeScript(e)?(setTimeout(function(){i._executeCommand("/etc/init.d/avahi-daemon restart")},2e3),!0):(this.log.error("Can't set hostname '"+t+"'"),!1)},t.prototype.setWifiAp=function(t,e){var i=""===e||void 0===e?"none":"psk2",o=(e=this._escapePwd(void 0===e?"":e),new ExecutionContext("set-network"));return o.param=["WIFI_AP",t,e,i],this.log.info("Change WIFI to access point mode! (SSID: "+t+")"),this._executeScript(o)},t.prototype.setWifiStation=function(t,e){var i=""===e||void 0===e?"none":"psk2",o=(e=this._escapePwd(void 0===e?"":e),new ExecutionContext("set-network"));return o.param=["WIFI_STA",t,e,i],this.log.info("Change WIFI to station mode! (SSID: "+t+")"),this._executeScript(o)},t.prototype._escapePwd=function(t){return t},t.prototype.getWifiStationIpAddress=function(){return this._getWifiIp()},t.prototype.isWifiStationEnabled=function(){try{var t=new ExecutionContext("uci get wireless.sta.disabled");return this._execute(t)?"0"===t.res:(this.log.error("Unable to get WIFI Station status!"),!1)}catch(t){this.log.error("Unable to get 'wireless.sta.disabled'")}return!0},t.prototype.commitWifiSettings=function(){this._executeCommand("uci commit wireless"),this._executeCommand("uci commit network")},t.prototype.getUptime=function(){var t=new ExecutionContext("awk '{print $1}' /proc/uptime");return this._execute(t)?t.res:(this.log.error("Error while getting /proc/uptime!"),"")},t.prototype.updateByNtp=function(){require("child_process").exec("sh /www/ati/scripts/ntp.sh")},t.prototype._getWifiOptions=function(t){var e={},i=new ExecutionContext("uci show wireless."+t);if(!this._execute(i))return this.log.error("Error while getting settings of '"+t+"'!"),{};for(var o=new RegExp("."+t+".(.*)='(.*)'","g"),r=o.exec(i.res);null!==r;)e[r[1]]=r[2],r=o.exec(i.res);return e},t.prototype._getWifiIp=function(){var t=new ExecutionContext("get-ip");return this._executeScript(t)&&""!==t.res?t.res:(this.log.warn("Unable to get local IP! Use fallback 192.168.100.1!"),"192.168.100.1")},t.prototype._executeScript=function(t){var e="";if(void 0!==t.param){for(var i=0;i<t.param.length;i++)e+=' "'+t.param[i]+'"';this.log.debug(e)}return t.cmd=this.version+"."+t.cmd+".sh"+e,t.cmd="sh /www/ati/scripts/"+t.cmd,this._execute(t)},t.prototype._execute=function(e){this.log.debug("exec: %s",e.cmd);var t=require("child_process").execSync;try{return e.res=_.trim(t(e.cmd).toString(),"\n"),this.log.debug("result: %s",e.res),e.success=!0}catch(t){return this.log.warn("err: %s",t.message),e.err=t.message,e.success=!1}},t.prototype._executeCommand=function(t){t=new ExecutionContext(t);return this._execute(t)},t}(),ExecutionContext=(exports.AbstractSystem=AbstractSystem,function(t){this.success=!1,this.cmd=t});exports.ExecutionContext=ExecutionContext;