/*! node-ati 2022-11-25 */
var _=require("lodash"),fs=require("fs"),Spot=require("./spot.js"),System=require("./../lib/openwrt/system.ts.js").Factory.create(),Datafile=require("./../lib/utils/datafile.js"),config=require("./../config.js"),log4js=require("log4js"),_log=log4js.getLogger("model.spots");function Spots(t,e){var o=this;if(this._initialized=void 0,this._items=[],this._dataFileName="./data/spots.json",this._dataFileNameLocal="./data/spots.local.json",this._settings=e,this._channelColors=null,this.maxLocalTemperature=0,this._checkTimeoutInterval=setInterval(function(){o._onCheckTimeoutInterval()},5e3),this._checkPowerInterval=setInterval(function(){o._onCheckPowerInterval()},3e5),this._cachedJson=void 0,(this._localItems=void 0)!==t){"object"==typeof t&&"function"==typeof t.getItems&&(t=t.getItems());for(var o=this,a=0;a<t.length;a++)o.add(new Spot(t[a]))}}Spots.prototype.Initialized=function(){return void 0===this._initialized&&(this._initialized=fs.existsSync(this._dataFileName)),this._initialized},Spots.prototype.add=function(t){_.some(this._items)&&(t._id=_.last(this._items)._id+1),void 0===t.externalId&&(t.externalId=this._createExternalId(t._id)),void 0===this.findByExternalId(t.externalId)&&this._items.push(t)},Spots.prototype.findById=function(e){return _.find(this._items,function(t){return t._id==e})},Spots.prototype.findByExternalId=function(e){return _.find(this._items,function(t){return t.externalId===e})},Spots.prototype.removeById=function(e){_.remove(this._items,function(t){return t._id==e})},Spots.prototype.save=function(){var t=this.getRawData();this._cachedJson=void 0,this._localItems=void 0,_log.info("Invalidate cached json data while saving..."),Datafile.writeData(t,this._dataFileName),this._initialized=!0},Spots.prototype.addExternalItems=function(t){var e=this;_.forEach(t.spots,function(t){void 0!==t.externalId&&void 0===_.find(e._items,{externalId:t.externalId})&&(_log.info("Add spot: "+t.externalId),e.add(new Spot(t)))})},Spots.prototype.getOwnItems=function(){return void 0===this._localItems&&(this._localItems=_.filter(this._items,function(t){return t.isLocal()})),this._localItems},Spots.prototype.getEnabledOwnItems=function(){return _.filter(this.getOwnItems(),function(t){return t.enabled})},Spots.prototype.getExternalItems=function(){return _.filter(this._items,function(t){return!t.isLocal()})},Spots.prototype.getItems=function(t){return this._items},Spots.prototype.getCachedJsonString=function(){return void 0===this._cachedJson&&(_log.info("Create cached json data."),this._cachedJson=JSON.stringify(this.getItems())),this._cachedJson},Spots.prototype.getChannelColors=function(){var e,o,a;return null===this._channelColors&&(e={},o=[],a=0,_.forEach(this._items,function(t){_.forEach(t.channels,function(t){_.has(e,t.name)||(e[t.name]={name:t.name,sort:void 0===t.sort?0:t.sort})})}),_.forOwn(e,function(t,e){o.push({id:a++,label:"COLORNAME_"+t.name,value:0,name:t.name,sort:t.sort})}),this._channelColors=o),this._channelColors},Spots.prototype.load=function(){this._load(this._dataFileName),_log.info("Invalidate cached json data while loading..."),this._cachedJson=void 0,this._localItems=void 0,fs.existsSync(this._dataFileNameLocal)||Datafile.writeData(this._getRawData(this.getOwnItems()),this._dataFileNameLocal),this._load(this._dataFileNameLocal,!1)},Spots.prototype._load=function(t,e){var o=Datafile.readData(t);if(void 0!==o){!1!==e&&(this._items=[]);for(var a=0;a<o.length;a++)this.add(new Spot(o[a]))}},Spots.prototype.getRawData=function(){return this._getRawData(_.filter(this._items,function(t){return-1!==_.parseInt(t._id)}))},Spots.prototype._getRawData=function(t){t=_.cloneDeep(t,!0);return _.map(t,function(t){return t.temperature=void 0,t.temperatureInvalid=void 0,t.lastOnlineUpdate=void 0,t.online=void 0,t.power=void 0,t._colorChannels=void 0,t})},Spots.prototype.updateLocalTemperature=function(a){var i=!1,n=0;_.forEach(this._items,function(t){if(!t.isLocal())return!0;var e,o;i||void 0!==_.find(t.channels,{address:a.address})&&(a.value<80&&0<a.value&&(e=Math.round(10*a.value)/10,70<=a.value&&(a.value=70),void 0===t.rawtemperature&&(t.rawtemperature=[]),void 0===(o=_.find(t.rawtemperature,function(t){return t.addr===a.address}))&&(o={value:e,addr:a.address},t.rawtemperature.push(o)),o.value=e,t.temperature=_.maxBy(t.rawtemperature,"value").value),t.lastOnlineUpdate=Date.now(),t.online=!0,i=!0),t.temperature>n&&(n=t.temperature)}),this.maxLocalTemperature=n},Spots.prototype.removeExternalItems=function(){this._items=_.remove(this._items,function(t){return!t.isLocal()})},Spots.prototype.removeByExternalId=function(e){this._items=_.remove(this._items,function(t){return!(t.isPartOfExternalId(e)&&!t.isLocal())})},Spots.prototype.updateOnlineState=function(e){var o=this,a=e.request.id,i=!1;return _.forEach(o._items,function(t){t.isPartOfExternalId(a)&&(t.lastOnlineUpdate=Date.now(),t.online=!0,t.ip!==e.remote.address&&(t.ip=e.remote.address,_log.info("Invalidate cached json data caused by getting new IP for client..."),o._cachedJson=void 0),i=!0)}),i},Spots.prototype._onCheckTimeoutInterval=function(){_.forEach(this._items,function(t){t.lastOnlineUpdate<Date.now()-(t.isLocal()?12e4:25e3)&&(t.online=!1)})},Spots.prototype._onCheckPowerInterval=function(){_.forEach(this._items,function(t){t.updatePower()})},Spots.prototype.updateExternalTemperature=function(t){var o=this;_.forEach(t,function(e){_.forEach(o._items,function(t){return!!t.isLocal()||(t.externalId===e.externalId?(t.temperature=e.temperature,t.rawtemperature=e.rawtemperature,!1):void 0)})})},Spots.prototype.getTemperatures=function(){var e=[];return _.forEach(this._items,function(t){e.push({externalId:t.externalId,temperature:t.temperature})}),e},Spots.prototype.setTemperatures=function(t){var o=this;_.forEach(t,function(e){_.forEach(o._items,function(t){if(t.externalId===e.externalId)return t.temperature=e.temperature,!1})})},Spots.prototype.getChannelColors=function(){var e,n,r;return null===this._channelColors&&(e={},n=[],r=0,_.forEach(this._items,function(t){_.forEach(t.channels,function(t){_.has(e,t.name)||(e[t.name]={name:t.name,sort:void 0===t.sort?0:t.sort})})}),_.forOwn(e,function(t,e){var o,a=1,i=void 0;void 0!==config.colorFactors&&void 0!==(o=_.find(config.colorFactors,{name:t.name}))&&(a=o.factor),void 0!==config.colorReduceTemperatures&&(i=_.find(config.colorReduceTemperatures,{name:t.name})),n.push({id:r++,label:"COLORNAME_"+t.name,value:0,name:t.name,sort:t.sort,factor:a,valueTemperature:i})}),this._channelColors=n),this._channelColors},Spots.prototype._createExternalId=function(t){return System.getId()+":"+t},Spots.prototype.getLocalCustomName=function(){var e="";return _.forEach(this._items,function(t){if(t.isLocal()&&void 0!==t.customName)return e=t.customName,!0}),e},Spots.prototype.setLocalCustomName=function(e){_.forEach(this._items,function(t){t.isLocal()&&(t.customName=e)})},Spots.prototype.enableLocalItems=function(t){if(this._localItems=void 0,this.getEnabledOwnItems().length!==t){var e=_.sortBy(this.getOwnItems(),["_id"]);0===t&&(t=3);for(var o=0;o<e.length;o++)e[o].enabled=o<t;this.save(),Datafile.writeData(this._getRawData(this.getOwnItems()),this._dataFileNameLocal)}},module.exports=Spots;