"use strict";var events=require("events"),async=require("async"),fs=require("fs"),path=require("path"),util=require("util"),layouts=require("./layouts"),levels=require("./levels"),loggerModule=require("./logger"),LoggingEvent=loggerModule.LoggingEvent,Logger=loggerModule.Logger,ALL_CATEGORIES="[all]",appenders={},loggers={},appenderMakers={},appenderShutdowns={},defaultConfig={appenders:[{type:"console"}],replaceConsole:!1};function hasLogger(e){return loggers.hasOwnProperty(e)}function getBufferedLogger(e){var e=getLogger(e),o={temp:[]};return o.target=e,o.flush=function(){for(var e=0;e<o.temp.length;e++){var r=o.temp[e];o.target[r.level](r.message),delete o.temp[e]}},o.trace=function(e){o.temp.push({level:"trace",message:e})},o.debug=function(e){o.temp.push({level:"debug",message:e})},o.info=function(e){o.temp.push({level:"info",message:e})},o.warn=function(e){o.temp.push({level:"warn",message:e})},o.error=function(e){o.temp.push({level:"error",message:e})},o.fatal=function(e){o.temp.push({level:"fatal",message:e})},o}function normalizeCategory(e){return e+"."}function doesLevelEntryContainsLogger(e,r){e=normalizeCategory(e);return normalizeCategory(r).substring(0,e.length)==e}function doesAppenderContainsLogger(e,r){e=normalizeCategory(e);return normalizeCategory(r).substring(0,e.length)==e}function getLogger(r){if("string"!=typeof r&&(r=Logger.DEFAULT_CATEGORY),!hasLogger(r)){var e,o=void 0;if(levels.config)for(var n=Object.keys(levels.config).sort(),t=0;t<n.length;t++){var g=n[t];doesLevelEntryContainsLogger(g,r)&&(o=levels.config[g])}for(e in loggers[r]=new Logger(r,o),appenders)doesAppenderContainsLogger(e,r)&&appenders[e].forEach(function(e){loggers[r].addListener("log",e)});appenders[ALL_CATEGORIES]&&appenders[ALL_CATEGORIES].forEach(function(e){loggers[r].addListener("log",e)})}return loggers[r]}function addAppender(){var e=Array.prototype.slice.call(arguments),o=e.shift();0!==e.length&&void 0!==e[0]||(e=[ALL_CATEGORIES]),Array.isArray(e[0])&&(e=e[0]),e.forEach(function(e){if(addAppenderToCategory(o,e),e===ALL_CATEGORIES)addAppenderToAllLoggers(o);else for(var r in loggers)doesAppenderContainsLogger(e,r)&&loggers[r].addListener("log",o)})}function addAppenderToAllLoggers(e){for(var r in loggers)hasLogger(r)&&loggers[r].addListener("log",e)}function addAppenderToCategory(e,r){appenders[r]||(appenders[r]=[]),appenders[r].push(e)}function clearAppenders(){for(var e in appenders={},loggers)hasLogger(e)&&loggers[e].removeAllListeners("log")}function configureAppenders(e,o){clearAppenders(),e&&e.forEach(function(r){loadAppender(r.type),r.makers=appenderMakers;try{addAppender(appenderMakers[r.type](r,o),r.category)}catch(e){throw new Error("log4js configuration problem for "+util.inspect(r),e)}})}function configureLevels(e){if(levels.config=e){var r,o=Object.keys(levels.config).sort();for(r in o){var n,t=o[r];for(n in t===ALL_CATEGORIES&&setGlobalLogLevel(e[t]),loggers)doesLevelEntryContainsLogger(t,n)&&loggers[n].setLevel(e[t])}}}function setGlobalLogLevel(e){Logger.prototype.level=levels.toLevel(e,levels.TRACE)}function getDefaultLogger(){return getLogger(Logger.DEFAULT_CATEGORY)}require("./appenders/console");var configState={};function loadConfigurationFile(e){if(e)return JSON.parse(fs.readFileSync(e,"utf8"))}function configureOnceOff(r,e){if(r)try{configureLevels(r.levels),configureAppenders(r.appenders,e),(r.replaceConsole?replaceConsole:restoreConsole)()}catch(e){throw new Error("Problem reading log4js config "+util.inspect(r)+'. Error was "'+e.message+'" ('+e.stack+")")}}function reloadConfiguration(e){var r=getMTime(configState.filename);r&&(configState.lastMTime&&r.getTime()>configState.lastMTime.getTime()&&configureOnceOff(loadConfigurationFile(configState.filename),e),configState.lastMTime=r)}function getMTime(r){var e;try{e=fs.statSync(configState.filename).mtime}catch(e){getLogger("log4js").warn("Failed to load configuration file "+r)}return e}function initReloadConfiguration(e,r){configState.timerId&&(clearInterval(configState.timerId),delete configState.timerId),configState.filename=e,configState.lastMTime=getMTime(e),configState.timerId=setInterval(reloadConfiguration,1e3*r.reloadSecs,r)}function configure(e,r){r=r||{},null==(e=e||process.env.LOG4JS_CONFIG)||"string"==typeof e?(r.reloadSecs&&initReloadConfiguration(e,r),e=loadConfigurationFile(e)||defaultConfig):r.reloadSecs&&getLogger("log4js").warn('Ignoring configuration reload parameter for "object" configuration.'),configureOnceOff(e,r)}var originalConsoleFunctions={log:console.log,debug:console.debug,info:console.info,warn:console.warn,error:console.error};function replaceConsole(o){o=o||getLogger("console"),["log","debug","info","warn","error"].forEach(function(e){var r;console[e]=(r="log"===e?o.info:o[e],function(){r.apply(o,arguments)})})}function restoreConsole(){["log","debug","info","warn","error"].forEach(function(e){console[e]=originalConsoleFunctions[e]})}function requireAppender(r){var o;try{o=require("./appenders/"+r)}catch(e){o=require(r)}return o}function loadAppender(e,r){if(!(r=r||requireAppender(e)))throw new Error("Invalid log4js appender: "+util.inspect(e));module.exports.appenders[e]=r.appender.bind(r),r.shutdown&&(appenderShutdowns[e]=r.shutdown.bind(r)),appenderMakers[e]=r.configure.bind(r)}function shutdown(e){loggerModule.disableAllLogWrites();var r=Object.keys(appenderShutdowns).reduce(function(e,r){return e.concat(appenderShutdowns[r])},[]);async.each(r,function(e,r){e(r)},e)}module.exports={getBufferedLogger:getBufferedLogger,getLogger:getLogger,getDefaultLogger:getDefaultLogger,hasLogger:hasLogger,addAppender:addAppender,loadAppender:loadAppender,clearAppenders:clearAppenders,configure:configure,shutdown:shutdown,replaceConsole:replaceConsole,restoreConsole:restoreConsole,levels:levels,setGlobalLogLevel:setGlobalLogLevel,layouts:layouts,appenders:{},appenderMakers:appenderMakers,connectLogger:require("./connect-logger").connectLogger},configure();