var qs=require("querystring"),parse=require("url").parse,base64id=require("base64id"),transports=require("./transports"),EventEmitter=require("events").EventEmitter,Socket=require("./socket"),util=require("util"),debug=require("debug")("engine"),cookieMod=require("cookie");function Server(e){if(!(this instanceof Server))return new Server(e);this.clients={},this.clientsCount=0,e=e||{},this.wsEngine=e.wsEngine||process.env.EIO_WS_ENGINE,this.pingTimeout=e.pingTimeout||6e4,this.pingInterval=e.pingInterval||25e3,this.upgradeTimeout=e.upgradeTimeout||1e4,this.maxHttpBufferSize=e.maxHttpBufferSize||1e8,this.transports=e.transports||Object.keys(transports),this.allowUpgrades=!1!==e.allowUpgrades,this.allowRequest=e.allowRequest,this.cookie=!1!==e.cookie&&(e.cookie||"io"),this.cookiePath=!1!==e.cookiePath&&(e.cookiePath||"/"),this.cookieHttpOnly=!1!==e.cookieHttpOnly,this.perMessageDeflate=!1!==e.perMessageDeflate&&(e.perMessageDeflate||!0),this.httpCompression=!1!==e.httpCompression&&(e.httpCompression||{});var t=this;["perMessageDeflate","httpCompression"].forEach(function(e){var r=t[e];!0===r&&(t[e]=r={}),r&&null==r.threshold&&(r.threshold=1024)}),~this.transports.indexOf("websocket")&&(e=(this.wsEngine?require(this.wsEngine):require("ws")).Server,this.ws=new e({noServer:!0,clientTracking:!1,perMessageDeflate:this.perMessageDeflate,maxPayload:this.maxHttpBufferSize}))}function sendErrorMessage(e,r,t){var s={"Content-Type":"application/json"};e.headers.origin?(s["Access-Control-Allow-Credentials"]="true",s["Access-Control-Allow-Origin"]=e.headers.origin):s["Access-Control-Allow-Origin"]="*",r.writeHead(400,s),r.end(JSON.stringify({code:t,message:Server.errorMessages[t]}))}function abortConnection(e,r){var t;e.writable&&(t=Server.errorMessages.hasOwnProperty(r)?Server.errorMessages[r]:r||"",r=Buffer.byteLength(t),e.write("HTTP/1.1 400 Bad Request\r\nConnection: close\r\nContent-type: text/html\r\nContent-Length: "+r+"\r\n\r\n"+t)),e.destroy()}(module.exports=Server).errors={UNKNOWN_TRANSPORT:0,UNKNOWN_SID:1,BAD_HANDSHAKE_METHOD:2,BAD_REQUEST:3},Server.errorMessages={0:"Transport unknown",1:"Session ID unknown",2:"Bad handshake method",3:"Bad request"},util.inherits(Server,EventEmitter),Server.prototype.clients,Server.prototype.upgrades=function(e){return this.allowUpgrades&&transports[e].upgradesTo||[]},Server.prototype.verify=function(e,r,t){var s=e._query.transport;if(!~this.transports.indexOf(s))return debug('unknown transport "%s"',s),t(Server.errors.UNKNOWN_TRANSPORT,!1);var n=e._query.sid;return n?this.clients.hasOwnProperty(n)?r||this.clients[n].transport.name===s?void t(null,!0):(debug("bad request: unexpected transport without upgrade"),t(Server.errors.BAD_REQUEST,!1)):t(Server.errors.UNKNOWN_SID,!1):"GET"!==e.method?t(Server.errors.BAD_HANDSHAKE_METHOD,!1):this.allowRequest?this.allowRequest(e,t):t(null,!0)},Server.prototype.prepare=function(e){e._query||(e._query=~e.url.indexOf("?")?qs.parse(parse(e.url).query):{})},Server.prototype.close=function(){for(var e in debug("closing all open clients"),this.clients)this.clients.hasOwnProperty(e)&&this.clients[e].close(!0);return this.ws&&(debug("closing webSocketServer"),this.ws.close()),this},Server.prototype.handleRequest=function(t,s){debug('handling "%s" http request "%s"',t.method,t.url),this.prepare(t),t.res=s;var n=this;this.verify(t,!1,function(e,r){r?t._query.sid?(debug("setting new request for existing client"),n.clients[t._query.sid].transport.onRequest(t)):n.handshake(t._query.transport,t):sendErrorMessage(t,s,e)})},Server.prototype.generateId=function(e){return base64id.generateId()},Server.prototype.handshake=function(e,r){var t=this.generateId(r);debug('handshaking client "%s"',t);try{var s=new transports[e](r);"polling"===e?(s.maxHttpBufferSize=this.maxHttpBufferSize,s.httpCompression=this.httpCompression):"websocket"===e&&(s.perMessageDeflate=this.perMessageDeflate),r._query&&r._query.b64?s.supportsBinary=!1:s.supportsBinary=!0}catch(e){return void sendErrorMessage(r,r.res,Server.errors.BAD_REQUEST)}var n=new Socket(t,this,s,r),o=this;!1!==this.cookie&&s.on("headers",function(e){e["Set-Cookie"]=cookieMod.serialize(o.cookie,t,{path:o.cookiePath,httpOnly:!!o.cookiePath&&o.cookieHttpOnly})}),s.onRequest(r),this.clients[t]=n,this.clientsCount++,n.once("close",function(){delete o.clients[t],o.clientsCount--}),this.emit("connection",n)},Server.prototype.handleUpgrade=function(t,s,n){this.prepare(t);var o=this;this.verify(t,!0,function(e,r){r?(r=new Buffer(n.length),n.copy(r),n=null,o.ws.handleUpgrade(t,s,r,function(e){o.onWebSocket(t,e)})):abortConnection(s,e)})},Server.prototype.onWebSocket=function(e,r){if(r.on("error",n),!transports[e._query.transport].prototype.handlesUpgrades)return debug("transport doesnt handle upgraded requests"),void r.close();var t,s=e._query.sid;function n(){debug("websocket error before upgrade")}e.websocket=r,s?(t=this.clients[s])?t.upgrading?(debug("transport has already been trying to upgrade"),r.close()):t.upgraded?(debug("transport had already been upgraded"),r.close()):(debug("upgrading existing transport"),r.removeListener("error",n),s=new transports[e._query.transport](e),e._query&&e._query.b64?s.supportsBinary=!1:s.supportsBinary=!0,s.perMessageDeflate=this.perMessageDeflate,t.maybeUpgrade(s)):(debug("upgrade attempt for closed client"),r.close()):(r.removeListener("error",n),this.handshake(e._query.transport,e))},Server.prototype.attach=function(n,s){var o=this,i=((s=s||{}).path||"/engine.io").replace(/\/$/,""),a=s.destroyUpgradeTimeout||1e3;function u(e){return i===e.url.substr(0,i.length)}i+="/";var p=n.listeners("request").slice(0);n.removeAllListeners("request"),n.on("close",o.close.bind(o)),n.on("request",function(e,r){if(u(e))debug('intercepting request for path "%s"',i),o.handleRequest(e,r);else for(var t=0,s=p.length;t<s;t++)p[t].call(n,e,r)}),~o.transports.indexOf("websocket")&&n.on("upgrade",function(e,r,t){u(e)?o.handleUpgrade(e,r,t):!1!==s.destroyUpgrade&&setTimeout(function(){if(r.writable&&r.bytesWritten<=0)return r.end()},a)})};