var EventEmitter=require("events").EventEmitter,util=require("util"),debug=require("debug")("engine:socket");function Socket(t,e,r,i){this.id=t,this.server=e,this.upgrading=!1,this.upgraded=!1,this.readyState="opening",this.writeBuffer=[],this.packetsFn=[],this.sentCallbackFn=[],this.cleanupFn=[],this.request=i,this.remoteAddress=i.connection.remoteAddress,this.checkIntervalTimer=null,this.upgradeTimeoutTimer=null,this.pingTimeoutTimer=null,this.setTransport(r),this.onOpen()}module.exports=Socket,util.inherits(Socket,EventEmitter),Socket.prototype.onOpen=function(){this.readyState="open",this.transport.sid=this.id,this.sendPacket("open",JSON.stringify({sid:this.id,upgrades:this.getAvailableUpgrades(),pingInterval:this.server.pingInterval,pingTimeout:this.server.pingTimeout})),this.emit("open"),this.setPingTimeout()},Socket.prototype.onPacket=function(t){if("open"===this.readyState)switch(debug("packet"),this.emit("packet",t),this.setPingTimeout(),t.type){case"ping":debug("got ping"),this.sendPacket("pong"),this.emit("heartbeat");break;case"error":this.onClose("parse error");break;case"message":this.emit("data",t.data),this.emit("message",t.data)}else debug("packet received with closed socket")},Socket.prototype.onError=function(t){debug("transport error"),this.onClose("transport error",t)},Socket.prototype.setPingTimeout=function(){var t=this;clearTimeout(t.pingTimeoutTimer),t.pingTimeoutTimer=setTimeout(function(){t.onClose("ping timeout")},t.server.pingInterval+t.server.pingTimeout)},Socket.prototype.setTransport=function(t){var e=this.onError.bind(this),r=this.onPacket.bind(this),i=this.flush.bind(this),s=this.onClose.bind(this,"transport close");this.transport=t,this.transport.once("error",e),this.transport.on("packet",r),this.transport.on("drain",i),this.transport.once("close",s),this.setupSendCallback(),this.cleanupFn.push(function(){t.removeListener("error",e),t.removeListener("packet",r),t.removeListener("drain",i),t.removeListener("close",s)})},Socket.prototype.maybeUpgrade=function(e){debug('might upgrade socket transport from "%s" to "%s"',this.transport.name,e.name),this.upgrading=!0;var r=this;function t(t){"ping"===t.type&&"probe"===t.data?(e.send([{type:"pong",data:"probe"}]),r.emit("upgrading",e),clearInterval(r.checkIntervalTimer),r.checkIntervalTimer=setInterval(i,100)):"upgrade"===t.type&&"closed"!==r.readyState?(debug("got upgrade packet - upgrading"),s(),r.transport.discard(),r.upgraded=!0,r.clearTransport(),r.setTransport(e),r.emit("upgrade",e),r.setPingTimeout(),r.flush(),"closing"===r.readyState&&e.close(function(){r.onClose("forced close")})):(s(),e.close())}function i(){"polling"===r.transport.name&&r.transport.writable&&(debug("writing a noop packet to polling for fast upgrade"),r.transport.send([{type:"noop"}]))}function s(){r.upgrading=!1,clearInterval(r.checkIntervalTimer),r.checkIntervalTimer=null,clearTimeout(r.upgradeTimeoutTimer),r.upgradeTimeoutTimer=null,e.removeListener("packet",t),e.removeListener("close",o),e.removeListener("error",n),r.removeListener("close",a)}function n(t){debug("client did not complete upgrade - %s",t),s(),e.close(),e=null}function o(){n("transport closed")}function a(){n("socket closed")}r.upgradeTimeoutTimer=setTimeout(function(){debug("client did not complete upgrade - closing transport"),s(),"open"===e.readyState&&e.close()},this.server.upgradeTimeout),e.on("packet",t),e.once("close",o),e.once("error",n),r.once("close",a)},Socket.prototype.clearTransport=function(){for(var t=this.cleanupFn.length,e=0;e<t;e++)this.cleanupFn.shift()();this.transport.on("error",function(){debug("error triggered by discarded transport")}),this.transport.close(),clearTimeout(this.pingTimeoutTimer)},Socket.prototype.onClose=function(t,e){var r;"closed"!==this.readyState&&(this.readyState="closed",clearTimeout(this.pingTimeoutTimer),clearInterval(this.checkIntervalTimer),this.checkIntervalTimer=null,clearTimeout(this.upgradeTimeoutTimer),r=this,process.nextTick(function(){r.writeBuffer=[]}),this.packetsFn=[],this.sentCallbackFn=[],this.clearTransport(),this.emit("close",t,e))},Socket.prototype.setupSendCallback=function(){var i=this;function t(){if(0<i.sentCallbackFn.length){var t=i.sentCallbackFn.splice(0,1)[0];if("function"==typeof t)debug("executing send callback"),t(i.transport);else if(Array.isArray(t)){debug("executing batch send callback");for(var e=t.length,r=0;r<e;r++)"function"==typeof t[r]&&t[r](i.transport)}}}this.transport.on("drain",t),this.cleanupFn.push(function(){i.transport.removeListener("drain",t)})},Socket.prototype.send=Socket.prototype.write=function(t,e,r){return this.sendPacket("message",t,e,r),this},Socket.prototype.sendPacket=function(t,e,r,i){"function"==typeof r&&(i=r,r=null),(r=r||{}).compress=!1!==r.compress,"closing"!==this.readyState&&(debug('sending packet "%s" (%s)',t,e),r={type:t,options:r},e&&(r.data=e),this.emit("packetCreate",r),this.writeBuffer.push(r),i&&this.packetsFn.push(i),this.flush())},Socket.prototype.flush=function(){var t;"closed"!==this.readyState&&this.transport.writable&&this.writeBuffer.length&&(debug("flushing buffer to transport"),this.emit("flush",this.writeBuffer),this.server.emit("flush",this,this.writeBuffer),t=this.writeBuffer,this.writeBuffer=[],this.transport.supportsFraming?this.sentCallbackFn.push.apply(this.sentCallbackFn,this.packetsFn):this.sentCallbackFn.push(this.packetsFn),this.packetsFn=[],this.transport.send(t),this.emit("drain"),this.server.emit("drain",this))},Socket.prototype.getAvailableUpgrades=function(){for(var t=[],e=this.server.upgrades(this.transport.name),r=0,i=e.length;r<i;++r){var s=e[r];-1!==this.server.transports.indexOf(s)&&t.push(s)}return t},Socket.prototype.close=function(t){"open"===this.readyState&&(this.readyState="closing",this.writeBuffer.length?this.once("drain",this.closeTransport.bind(this,t)):this.closeTransport(t))},Socket.prototype.closeTransport=function(t){t&&this.transport.discard(),this.transport.close(this.onClose.bind(this,"forced close"))};