var eio=require("engine.io-client"),Socket=require("./socket"),Emitter=require("component-emitter"),parser=require("socket.io-parser"),on=require("./on"),bind=require("component-bind"),debug=require("debug")("socket.io-client:manager"),indexOf=require("indexof"),Backoff=require("backo2"),has=Object.prototype.hasOwnProperty;function Manager(t,e){if(!(this instanceof Manager))return new Manager(t,e);t&&"object"==typeof t&&(e=t,t=void 0),(e=e||{}).path=e.path||"/socket.io",this.nsps={},this.subs=[],this.opts=e,this.reconnection(!1!==e.reconnection),this.reconnectionAttempts(e.reconnectionAttempts||1/0),this.reconnectionDelay(e.reconnectionDelay||1e3),this.reconnectionDelayMax(e.reconnectionDelayMax||5e3),this.randomizationFactor(e.randomizationFactor||.5),this.backoff=new Backoff({min:this.reconnectionDelay(),max:this.reconnectionDelayMax(),jitter:this.randomizationFactor()}),this.timeout(null==e.timeout?2e4:e.timeout),this.readyState="closed",this.uri=t,this.connecting=[],this.lastPing=null,this.encoding=!1,this.packetBuffer=[],this.encoder=new parser.Encoder,this.decoder=new parser.Decoder,this.autoConnect=!1!==e.autoConnect,this.autoConnect&&this.open()}(module.exports=Manager).prototype.emitAll=function(){for(var t in this.emit.apply(this,arguments),this.nsps)has.call(this.nsps,t)&&this.nsps[t].emit.apply(this.nsps[t],arguments)},Manager.prototype.updateSocketIds=function(){for(var t in this.nsps)has.call(this.nsps,t)&&(this.nsps[t].id=this.engine.id)},Emitter(Manager.prototype),Manager.prototype.reconnection=function(t){return arguments.length?(this._reconnection=!!t,this):this._reconnection},Manager.prototype.reconnectionAttempts=function(t){return arguments.length?(this._reconnectionAttempts=t,this):this._reconnectionAttempts},Manager.prototype.reconnectionDelay=function(t){return arguments.length?(this._reconnectionDelay=t,this.backoff&&this.backoff.setMin(t),this):this._reconnectionDelay},Manager.prototype.randomizationFactor=function(t){return arguments.length?(this._randomizationFactor=t,this.backoff&&this.backoff.setJitter(t),this):this._randomizationFactor},Manager.prototype.reconnectionDelayMax=function(t){return arguments.length?(this._reconnectionDelayMax=t,this.backoff&&this.backoff.setMax(t),this):this._reconnectionDelayMax},Manager.prototype.timeout=function(t){return arguments.length?(this._timeout=t,this):this._timeout},Manager.prototype.maybeReconnectOnOpen=function(){!this.reconnecting&&this._reconnection&&0===this.backoff.attempts&&this.reconnect()},Manager.prototype.open=Manager.prototype.connect=function(n,t){if(debug("readyState %s",this.readyState),~this.readyState.indexOf("open"))return this;debug("opening %s",this.uri),this.engine=eio(this.uri,this.opts);var e=this.engine,o=this;this.readyState="opening",this.skipReconnect=!1;var i,s,c=on(e,"open",function(){o.onopen(),n&&n()}),r=on(e,"error",function(t){var e;debug("connect_error"),o.cleanup(),o.readyState="closed",o.emitAll("connect_error",t),n?((e=new Error("Connection error")).data=t,n(e)):o.maybeReconnectOnOpen()});return!1!==this._timeout&&(i=this._timeout,debug("connect attempt will timeout after %d",i),s=setTimeout(function(){debug("connect attempt timed out after %d",i),c.destroy(),e.close(),e.emit("error","timeout"),o.emitAll("connect_timeout",i)},i),this.subs.push({destroy:function(){clearTimeout(s)}})),this.subs.push(c),this.subs.push(r),this},Manager.prototype.onopen=function(){debug("open"),this.cleanup(),this.readyState="open",this.emit("open");var t=this.engine;this.subs.push(on(t,"data",bind(this,"ondata"))),this.subs.push(on(t,"ping",bind(this,"onping"))),this.subs.push(on(t,"pong",bind(this,"onpong"))),this.subs.push(on(t,"error",bind(this,"onerror"))),this.subs.push(on(t,"close",bind(this,"onclose"))),this.subs.push(on(this.decoder,"decoded",bind(this,"ondecoded")))},Manager.prototype.onping=function(){this.lastPing=new Date,this.emitAll("ping")},Manager.prototype.onpong=function(){this.emitAll("pong",new Date-this.lastPing)},Manager.prototype.ondata=function(t){this.decoder.add(t)},Manager.prototype.ondecoded=function(t){this.emit("packet",t)},Manager.prototype.onerror=function(t){debug("error",t),this.emitAll("error",t)},Manager.prototype.socket=function(t,e){var n,o=this.nsps[t];function i(){~indexOf(n.connecting,o)||n.connecting.push(o)}return o||(o=new Socket(this,t,e),this.nsps[t]=o,n=this,o.on("connecting",i),o.on("connect",function(){o.id=n.engine.id}),this.autoConnect&&i()),o},Manager.prototype.destroy=function(t){t=indexOf(this.connecting,t);~t&&this.connecting.splice(t,1),this.connecting.length||this.close()},Manager.prototype.packet=function(n){debug("writing packet %j",n);var o=this;n.query&&0===n.type&&(n.nsp+="?"+n.query),o.encoding?o.packetBuffer.push(n):(o.encoding=!0,this.encoder.encode(n,function(t){for(var e=0;e<t.length;e++)o.engine.write(t[e],n.options);o.encoding=!1,o.processPacketQueue()}))},Manager.prototype.processPacketQueue=function(){var t;0<this.packetBuffer.length&&!this.encoding&&(t=this.packetBuffer.shift(),this.packet(t))},Manager.prototype.cleanup=function(){debug("cleanup");for(var t=this.subs.length,e=0;e<t;e++)this.subs.shift().destroy();this.packetBuffer=[],this.encoding=!1,this.lastPing=null,this.decoder.destroy()},Manager.prototype.close=Manager.prototype.disconnect=function(){debug("disconnect"),this.skipReconnect=!0,this.reconnecting=!1,"opening"===this.readyState&&this.cleanup(),this.backoff.reset(),this.readyState="closed",this.engine&&this.engine.close()},Manager.prototype.onclose=function(t){debug("onclose"),this.cleanup(),this.backoff.reset(),this.readyState="closed",this.emit("close",t),this._reconnection&&!this.skipReconnect&&this.reconnect()},Manager.prototype.reconnect=function(){if(this.reconnecting||this.skipReconnect)return this;var t,e,n=this;this.backoff.attempts>=this._reconnectionAttempts?(debug("reconnect failed"),this.backoff.reset(),this.emitAll("reconnect_failed"),this.reconnecting=!1):(t=this.backoff.duration(),debug("will wait %dms before reconnect attempt",t),this.reconnecting=!0,e=setTimeout(function(){n.skipReconnect||(debug("attempting reconnect"),n.emitAll("reconnect_attempt",n.backoff.attempts),n.emitAll("reconnecting",n.backoff.attempts),n.skipReconnect||n.open(function(t){t?(debug("reconnect attempt error"),n.reconnecting=!1,n.reconnect(),n.emitAll("reconnect_error",t.data)):(debug("reconnect success"),n.onreconnect())}))},t),this.subs.push({destroy:function(){clearTimeout(e)}}))},Manager.prototype.onreconnect=function(){var t=this.backoff.attempts;this.reconnecting=!1,this.backoff.reset(),this.updateSocketIds(),this.emitAll("reconnect",t)};