describe("Ultron",function(){"use strict";var o,t,e=require("eventemitter3"),i=require("events").EventEmitter,l=require("assume"),r=require("./");beforeEach(function(){t=new e,o=new r(t)}),afterEach(function(){o.destroy(),t.removeAllListeners()}),it("is exposed as a function",function(){l(r).is.a("function")}),it("can be initialized without the new keyword",function(){l(r(t)).is.instanceOf(r)}),it("assigns a unique id to every instance",function(){for(var e=0;e<100;e++)l(o.id).does.not.equal((new r).id)}),it("allows removal through the event emitter",function(){function e(){}function n(){}o.on("foo",e),o.once("foo",n),l(e.__ultron).equals(o.id),l(n.__ultron).equals(o.id),l(t.listeners("foo").length).equals(2),t.removeListener("foo",e),l(t.listeners("foo").length).equals(1),t.removeListener("foo",n),l(t.listeners("foo").length).equals(0)}),describe("#on",function(){it("assigns a listener",function(){function e(){}l(t.listeners("foo").length).equals(0),o.on("foo",e),l(t.listeners("foo").length).equals(1),l(t.listeners("foo")[0]).equals(e)}),it("tags the assigned function",function(){l(t.listeners("foo").length).equals(0),o.on("foo",function(){}),l(t.listeners("foo")[0].__ultron).equals(o.id)}),it("also passes in the context",function(s){o.on("foo",function(e,n,o){l(e).equals("a"),l(n).equals("b"),l(o).equals("c"),l(this).equals(1313),s()},1313),t.emit("foo","a","b","c")}),it("works with regular eventemitters as well",function(s){var e=new i;new r(e).on("foo",function(e,n,o){l(e).equals("a"),l(n).equals("b"),l(o).equals("c"),s()}),e.emit("foo","a","b","c")})}),describe("#once",function(){it("assigns a listener",function(){function e(){}l(t.listeners("foo").length).equals(0),o.once("foo",e),l(t.listeners("foo").length).equals(1),l(t.listeners("foo")[0]).equals(e)}),it("tags the assigned function",function(){l(t.listeners("foo").length).equals(0),o.once("foo",function(){}),l(t.listeners("foo")[0].__ultron).equals(o.id)}),it("also passes in the context",function(s){o.once("foo",function(e,n,o){l(e).equals("a"),l(n).equals("b"),l(o).equals("c"),l(this).equals(1313),s()},1313),t.emit("foo","a","b","c"),t.emit("foo","a","b","c")}),it("works with regular eventemitters as well",function(s){var e=new i;new r(e).once("foo",function(e,n,o){l(e).equals("a"),l(n).equals("b"),l(o).equals("c"),s()}),e.emit("foo","a","b","c"),e.emit("foo","a","b","c")})}),describe("#remove",function(){it("removes only our assigned `on` listeners",function(){function e(){}t.on("foo",e),o.on("foo",function(){}),l(t.listeners("foo").length).equals(2),o.remove("foo"),l(t.listeners("foo").length).equals(1),l(t.listeners("foo")[0]).equals(e)}),it("removes our private __ultron references",function(){function e(){}function n(){}l("__ultron"in e).is.false(),l("__ultron"in n).is.false(),o.on("foo",n),o.once("bar",e),l("__ultron"in e).is.true(),l("__ultron"in n).is.true(),o.remove("foo, bar"),l("__ultron"in e).is.false(),l("__ultron"in n).is.false(),o.destroy(),t=new i,o=new r(t),l("__ultron"in e).is.false(),l("__ultron"in n).is.false(),o.on("foo",n),o.once("bar",e),l("__ultron"in e).is.true(),l("__ultron"in n).is.true(),o.remove("foo, bar"),l("__ultron"in e).is.false(),l("__ultron"in n).is.false()}),it("removes only our assigned `once` listeners",function(){function e(){}t.once("foo",e),o.once("foo",function(){}),l(t.listeners("foo").length).equals(2),o.remove("foo"),l(t.listeners("foo").length).equals(1),l(t.listeners("foo")[0]).equals(e)}),it("removes only our assigned `once` listeners from regular EE",function(){var e=new i,n=new r(e);function o(){}e.once("foo",o),n.once("foo",function(){}),l(e.listeners("foo").length).equals(2),n.remove("foo"),l(e.listeners("foo").length).equals(1),l(e.listeners("foo")[0].listener).equals(o)}),it("removes all assigned events if called without args",function(){o.on("foo",function(){}),o.on("bar",function(){}),l(t.listeners("foo").length).equals(1),l(t.listeners("bar").length).equals(1),o.remove(),l(t.listeners("foo").length).equals(0),l(t.listeners("bar").length).equals(0)}),it("removes multiple listeners based on args",function(){o.on("foo",function(){}),o.on("bar",function(){}),o.on("baz",function(){}),l(t.listeners("foo").length).equals(1),l(t.listeners("bar").length).equals(1),l(t.listeners("baz").length).equals(1),o.remove("foo","bar"),l(t.listeners("foo").length).equals(0),l(t.listeners("bar").length).equals(0),l(t.listeners("baz").length).equals(1)}),it("removes multiple listeners if first arg is seperated string",function(){o.on("foo",function(){}),o.on("bar",function(){}),o.on("baz",function(){}),l(t.listeners("foo").length).equals(1),l(t.listeners("bar").length).equals(1),l(t.listeners("baz").length).equals(1),o.remove("foo, bar"),l(t.listeners("foo").length).equals(0),l(t.listeners("bar").length).equals(0),l(t.listeners("baz").length).equals(1)})}),describe("#destroy",function(){it("removes all listeners",function(){o.on("foo",function(){}),o.on("bar",function(){}),o.on("baz",function(){}),l(t.listeners("foo").length).equals(1),l(t.listeners("bar").length).equals(1),l(t.listeners("baz").length).equals(1),o.destroy(),l(t.listeners("foo").length).equals(0),l(t.listeners("bar").length).equals(0),l(t.listeners("baz").length).equals(0)}),it("removes the .ee reference",function(){l(o.ee).equals(t),o.destroy(),l(o.ee).equals(null)}),it("returns booleans for state indication",function(){l(o.destroy()).is.true(),l(o.destroy()).is.false(),l(o.destroy()).is.false(),l(o.destroy()).is.false()})})});