/*! node-ati 2022-11-25 */
var sha1=require("sha1"),_=require("lodash"),Timelines=require("./model/timelines.js"),Timeline=require("./model/timeline.js"),log4js=require("log4js"),logger=log4js.getLogger("requests"),System=require("./lib/openwrt/system.ts.js").Factory.create(),FirmwareUpdate=require("./lib/utils/firmware-update.ts.js").FirmwareUpdate;function Requests(e){this._network=e.network,this._appSettings=e.appSettings,this._io=e.io,this._version=e.version,this._lines=e.lines,this._spots=e.spots,this._time=e.time,this._colors=e.colors,this._state=e.state,this._dimmer=e.dimmer,this._config=e.config,this._currentUser={name:"admin",sessionId:void 0}}Requests.prototype.updateData=function(e){this._network=void 0!==e.network?e.network:this._network,this._appSettings=void 0!==e.appSettings?e.appSettings:this._appSettings,this._io=void 0!==e.io?e.io:this._io,this._version=void 0!==e.version?e.version:this._version,this._lines=void 0!==e.lines?e.lines:this._lines,this._spots=void 0!==e.spots?e.spots:this._spots,this._colors=void 0!==e.colors?e.colors:this._colors},Requests.prototype.auth=function(e,t,s){e.session.user&&e.session.id===this._currentUser.sessionId?s():(e.session.error="Access denied!",t.send(401,"Access denied!"))},Requests.prototype.index=function(e,t){e.session.user&&e.session.id===this._currentUser.sessionId?this._config.isDebug||!0!==this._appSettings.showWizard()?t.sendfile("./public/_index.html"):t.sendfile("./public/_setup.html"):t.redirect("/login")},Requests.prototype.login=function(e,t){t.sendfile("./public/_login.html")},Requests.prototype.setup=function(e,t){t.sendfile("./public/_setup.html")},Requests.prototype.debugTemperatures=function(e,t){t.sendfile("./public/_debug-temperatures.html")},Requests.prototype.test=function(e,t){var s=this;!0!==s._appSettings.all().initialized&&sha1("admin")===s._appSettings.all().user.password?e.session.regenerate(function(){e.session.user={username:"admin"},s._currentUser.sessionId=e.session.id,t.sendfile("./public/_test.html")}):t.redirect("/login")},Requests.prototype.simulate=function(e,t){var s=this;sha1("admin")===s._appSettings.all().user.password?e.session.regenerate(function(){e.session.user={username:"admin"},s._currentUser.sessionId=e.session.id,t.sendfile("./public/_simulate.html")}):t.redirect("/login")},Requests.prototype.loginUser=function(e,t){var s=this;e.body.username==s._appSettings.all().user.name&&sha1(e.body.password)===s._appSettings.all().user.password?e.session.regenerate(function(){s._network.sendUdpCommand("logout"),s._io.emit("logout"),e.session.user={username:"admin"},s._currentUser.sessionId=e.session.id,t.redirect("/")}):t.redirect("/login")},Requests.prototype.loginToken=function(e,t){var s=this;require("./lib/utils/token-auth.ts.js").TokenAuth.validateToken(e.params.token)?e.session.regenerate(function(){s._network.sendUdpCommand("logout"),s._io.emit("logout"),e.session.user={username:"admin"},s._currentUser.sessionId=e.session.id,t.redirect("/")}):t.redirect("/login")},Requests.prototype.createLoginTokenByUser=function(e,t){e=require("./lib/utils/token-auth.ts.js").TokenAuth.createTokenByUser(e.body.username,e.body.password);t.send({token:e,valid:1<e.length})},Requests.prototype.checkToken=function(e,t){var s=require("./lib/utils/token-auth.ts.js").TokenAuth.validateToken(e.params.token);t.send({token:e.params.token,valid:s})},Requests.prototype.createLoginToken=function(e,t){var s=require("./lib/utils/token-auth.ts.js").TokenAuth.createToken();t.send({token:s,valid:1<s.length})},Requests.prototype.version=function(e,t){t.json(this._version)},Requests.prototype.state=function(e,t){t.json({initialized:this._lines.Initialized()})},Requests.prototype.info=function(e,t){t.json({id:System.getId(),adc:void 0!==this._config.hasADC&&this._config.hasADC,showAllTemperatures:void 0!==this._config.showAllTemperatures&&this._config.showAllTemperatures,maxTemperature:this._config.maxTemperature,isMaster:this._appSettings.all().isMaster})},Requests.prototype.user=function(e,t){t.json(this._appSettings.all().user)},Requests.prototype.uptime=function(e,t){seconds=Number(System.getUptime()),t.json({uptime:seconds,days:Math.floor(seconds/86400),hours:Math.floor(seconds%86400/3600),minutes:Math.floor(seconds%3600/60),seconds:Math.floor(seconds%60)})},Requests.prototype.channels=function(e,t){t.json(_.sortBy(this._spots.getChannelColors(),["sort","name"]))},Requests.prototype.spots=function(e,t){this._cachedJsonResponse(this._spots.getCachedJsonString(),e,t)},Requests.prototype.timelinesCached=function(e,t){this._cachedJsonResponse(this._lines.getCachedJsonString(),e,t)},Requests.prototype.timelines=function(e,t){this._cachedJsonResponse(this._lines.getCachedJsonString(),e,t)},Requests.prototype.timelinesAsFile=function(e,t){var s={timelines:this._lines.getDownloadData(),colors:this._colors.getDownloadData(),version:this._version.number};t.setHeader("Content-Type","application/json"),t.setHeader("Content-disposition","attachment; filename=ati.settings.json"),t.json(s)},Requests.prototype._cachedJsonResponse=function(e,t,s){s.setHeader("Content-Type","application/json"),s.statusCode=200,s.write(e),s.end()},Requests.prototype.timelinePut=function(e,t){var e=new Timelines(e.body.timelines),s=_.last(e.getItems());(s=void 0===s?new Timeline:((s=_.cloneDeep(s)).spots=[],s._id=void 0,new Timeline(s))).active=!0,e.add(s),t.json(s)},Requests.prototype.spotsVisiblePut=function(e,t){var s=e.body.spots,e=e.body.active;this._network.sendUdpMessageTwice("spots-active",{spots:s,active:e}),this._dimmer.setActiveSpots(s,e),t.json({succes:!0})},Requests.prototype.resetDevicePost=function(e,i){(0,require("child_process").exec)("./reset-settings.sh --force",function(e,t,s){e&&i.json({succes:!1}),i.json({succes:!0})})},Requests.prototype.changeUserPassword=function(s,i){var e=require("./lib/openwrt/user.js");this._appSettings.all().user.name=s.body.user.name,this._appSettings.all().user.password=sha1(s.body.user.password),this._appSettings.save(),e.setPW("root",s.body.user.password,function(e,t){e?logger.info("Change password for user "+s.body.user.name):logger.error("Error while changing password for user "+s.body.user.name+" message: "+t),i.json({valid:e,message:t})})},Requests.prototype.getPresettings=function(e,t){var s=new(require("./model/presettings.js")),s=(s.load(),s.getEnabledItems());t.json(s)},Requests.prototype.loadPresettings=function(e,t){var s=require("./lib/utils/merge-settings.js"),i=new(require("./model/presettings.js")),i=(i.load(),i.findById(e.body._id)),o="./data/presettings/";i.isCustom&&(o="./data/presettings.custom/"),void 0!==i&&(s=s(o+i.filename,i.isCustom,e.body.intensity,e.body.start,e.body.end,!i.isCustom,e.body.groups),t.json(s)),t.json({valid:!1})},Requests.prototype.getTimeInfo=function(e,t){t.json({ts:this._time.getUtc(),offset:this._time.getOffset(),timezone:this._time.getTimezone(),systime:this._time.get(),tsWithTz:this._time.getTsWithTz(),initialized:this._time.isInitialized()})},Requests.prototype.getTimeString=function(e,t){var s=this._time.get();t.json({time:s.toTimeString(),date:s.toDateString()})},Requests.prototype.getTime=function(e,t){t.send(new Date(this._time.getTsWithTz()).toISOString())},Requests.prototype.getTimezone=function(e,t){t.json({timezone:this._time.getTimezone()})},Requests.prototype.setTimezone=function(e,t){var s=this._time.setTimezone(e.body.timezone);this._network.sendUdpMessage("set-timezone",{tz:e.body.timezone}),s?(t.json({valid:!0,reset:!0}),System.restartProcess()):t.json({valid:!0,reset:!1})},Requests.prototype.setStartupTime=function(e,t){this._time.setStartupTime(e.body.startuptime),this._network.sendUdpMessage("set-start-up-time",{mode:e.body.startuptime}),t.json({valid:!0})},Requests.prototype.getStartupTime=function(e,t){t.json({startuptime:this._time.getStartupTime()})},Requests.prototype.getColors=function(e,t){var s=require("./lib/utils/get-colors.js");t.json(s(this._spots,this._colors))},Requests.prototype.getWifis=function(e,t){System.scanWifis(function(e){t.json(e)})},Requests.prototype.getWifiStatus=function(e,t){System.getWifiStatus(function(e){t.json(e)})},Requests.prototype.getNetworkConfig=function(e,t){var s={ap:System.getWifiApConfig(),sta:System.getWifiStationConfig(),staIP:System.getWifiStationIpAddress(),staEnabled:System.isWifiStationEnabled(),hostname:System.getHostname()};t.json(s)},Requests.prototype.setNetworkConfig=function(e,t){logger.trace(e.body);var s=!1;"sta"===e.body.mode?(System.setWifiStation(e.body.ssid,e.body.password),s=!(this._appSettings.all().isMaster=!1)):"ap"===e.body.mode&&(System.setWifiAp(e.body.ssid,e.body.password),s=this._appSettings.all().isMaster=!0),""!==e.body.hostname&&System.setHostname(e.body.hostname),System.commitWifiSettings(),this._appSettings.save(),t.json({result:!0,rebootNeeded:s})},Requests.prototype.setHostname=function(e,t){e=e.body.hostname;void 0!==e&&""!==e||(e=System.getDefaultHostname()),setTimeout(function(){System.reboot()},3e3),t.json({result:System.setHostname(e),hostname:e})},Requests.prototype.getHostname=function(e,t){t.json({hostname:System.getHostname()})},Requests.prototype.reboot=function(e,t){setTimeout(function(){System.reboot()},500),t.json({result:!0})},Requests.prototype.getTemperatures=function(e,t){t.sendfile("./data/temperature.log")},Requests.prototype.getRawTemperatures=function(e,t){this._config.rawTemperatureLogfile?t.sendfile("./data/"+this._config.rawTemperatureLogfile):t.redirect("/")},Requests.prototype.removeTimeline=function(e,t){var s=new(require("./model/timelines.js"))(e.body.timelines);s.removeById(e.body.deleteTimelineId),s.setSpots(this._spots),s.setColors(this._colors),t.json(s.getItems())},Requests.prototype.loadSettingsFile=function(e,t){var s=require("./lib/utils/datafile.js"),i=require("./lib/utils/merge-settings.js"),e=e.files.selected_file;e&&""!==e.originalFilename&&(logger.info("try to merge backup file "+e.path),i=i(e.path,!0),s.cleanTempFolder(),t.json(i)),t.json({valid:!1})},Requests.prototype.createSupportFile=function(e,i){this._config.isDebug?i.json({success:!0}):(0,require("child_process").exec)("./scripts/create-debug-info.sh",function(e,t,s){e&&i.json({success:!1,msg:e}),i.json({success:!0})})},Requests.prototype.getSupportFile=function(e,t){t.sendfile("./support.tar.gz")},Requests.prototype.getDevices=function(e,s){this._network.sendClientMessageAll({command:"get-device-info"}).then(function(e){var t=[];_.each(e,function(e){t.push(e.data)}),s.json(t)}).catch(function(){s.json([])})},Requests.prototype.getLoginPageInfo=function(e,t){t.json({name:System.getHostname(),id:System.getId(),customName:this._spots.getLocalCustomName(),version:this._version})},Requests.prototype.postFirmwareUpdateFile=function(e,i){var o=e.files.selected_file,n=!1,r="";this._config.isDebug&&(n=!0,o.originalFilename=""),o&&0<o.originalFilename.indexOf(".tar")?(require("./lib/utils/datafile.js").cleanTempFolder(o.path),i.json({valid:!0,file:o.path,original:o.originalFilename,msg:r})):o&&""!==o.originalFilename?(n=!0,(0,require("child_process").exec)("sysupgrade -T "+o.path,function(e,t,s){""!==t&&(logger.error(t),r=t,n=!1),i.json({valid:n,file:o.path,original:o.originalFilename,msg:r})})):i.json({valid:n,file:o.path,original:o.originalFilename,msg:r})},Requests.prototype.checkFirmwareUpdateOnline=function(e,t){var s=new FirmwareUpdate("straton",this._version.number);s.isConnectedToInternet(function(e){e?s.checkForUpdate().then(function(e){t.json({success:!0,data:e})}):t.json({success:!1,error:"ERROR_NO_INTERNETCONNECTION"})})},Requests.prototype.downloadFirmwareUpdateOnline=function(e,t){var e=e.params.url,s=new FirmwareUpdate("straton","");logger.info("download firmware update from "+e),s.download(e).then(function(e){e.success?t.json(e):t.json({success:!1,error:"ERROR_DOWNLOAD_FIRMWARE"})}).catch(function(e){t.json({success:!1,error:"ERROR_DOWNLOAD_FIRMWARE",msg:e})})},Requests.prototype.executeFirmwareUpdateFile=function(e,t){var n=e.params.filename,r=this;setTimeout(function(){for(var e=new FirmwareUpdate("straton",""),t=r._network.getConnections(),s=_.keys(t),i=[],o=0;o<s.length;o++)i.push(t[s[o]].address);e.publishFirmwareFile(i,n).then(function(){logger.info("finished uploading firmware update to all clients in the network..."),e.execute(n,{tarM:"linkit"!==System.version})}).catch(function(){logger.error("Unknown error while uploading firmware update to all clients in the network..."),e.execute(n,{tarM:"linkit"!==System.version})})},2e3),t.json({file:n,redirect:"/login"})},Requests.prototype.getIgnoredHelpDialogs=function(e,t){var s=this._appSettings.all().ignoreHelpDialogs;t.json({ignoreHelpDialogs:s=void 0===s?[]:s})},Requests.prototype.ignoreHelpDialogs=function(e,t){void 0===this._appSettings.all().ignoreHelpDialogs&&(this._appSettings.all().ignoreHelpDialogs=[]),!0===e.body.ignore?this._appSettings.all().ignoreHelpDialogs.push("ALL"):this._appSettings.all().ignoreHelpDialogs=[],this._appSettings.save(),t.json({ignoreHelpDialogs:this._appSettings.all().ignoreHelpDialogs})},Requests.prototype.ignoreHelpDialog=function(e,t){void 0===this._appSettings.all().ignoreHelpDialogs&&(this._appSettings.all().ignoreHelpDialogs=[]),this._appSettings.all().ignoreHelpDialogs.push(e.body.id),this._appSettings.save(),t.json({ignoreHelpDialogs:this._appSettings.all().ignoreHelpDialogs})},Requests.prototype.saveCustomPresetting=function(e,t){var s=e.params.slotId,i=new(require("./model/presettings.js"));i.load(),i.addCustom("custom",e.body,s),i.save(),t.json({success:!0})},module.exports=Requests;